------------------------------------------
--        Potion Maker Extended         --
--          by facit & Khrill           --
--                                      --
--               v 1.6.1                --
------------------------------------------

PotMakerXL = {
	name = "Potion Maker",
	version = "1.6.1",
	ResultControls = {},
    MustFilterControls = {},
    MustNotFilterControls = {},
    SolventFilterControls = {},
    ReagentFilterControls = {},
	onlyReagentFilter = nil,
	potion2ReagentFilter = nil,
	nameContainsFilter = "",
--    usedSolvent = nil,
    doablePotions = {},
    atAlchemyStation = false,
    menuID = nil,
    dataDefaults = {
        resultsWindowX = 0,
        resultsWindowY = 0,
        mainWindowX = 0,
        mainWindowY = 0,
		enableButton = true,
        useUnknown = true,
        useMissing = false,
        fakeThirdSlot = false,
        training = false,
        sameWindowCoords = true,
		XPMode = true,
		reagentStackOrder = false,
		reagentLevelColor = false
    },
    resultsMaxIndex = 0,
	BagMode = true,
	BankMode = true
}

local TEXTURE_REAGENTUNKNOWN = "PotionMakerExtended/art/reagent.dds"
local TEXTURE_TRAITUNKNOWN = "/esoui/art/ava/ava_transitlocked.dds"
local TEXTURE_HIGHLIGHT = "PotionMakerExtended/art/gridItem_outline.dds"
local TEXTURE_CLOSE = "/esoui/art/buttons/cancel_up.dds"
local TEXTURE_BAG = "/esoui/art/mainmenu/menubar_inventory_down.dds"
local TEXTURE_BANK = "PotionMakerExtended/art/chest.dds"
local TEXTURE_ENABLEBUTTON = "/esoui/art/progression/icon_alchemist.dds"

local COLOR_KHRILLSELECT = "FF6A00" -- orange ^^
local COLOR_DISABLED = "A0A0A0" -- gray

local language = ""
local PotionMakerSavedVariables = {}

local LIBMW = LibStub:GetLibrary("LibMsgWin-1.0")
local PotionMakerXLMsgWindow

local function HexToRGBA( hex )
	if string.len(hex) == 6 then hex = hex.."FF" end
    local rhex, ghex, bhex, ahex = string.sub(hex, 1, 2), string.sub(hex, 3, 4), string.sub(hex, 5, 6), string.sub(hex, 7, 8)
    return tonumber(rhex, 16)/255, tonumber(ghex, 16)/255, tonumber(bhex, 16)/255
end
local function IsThirdAlchemySlotUnlocked() --API fct deleted in 100010
	return ZO_Alchemy_IsThirdAlchemySlotUnlocked() --true
end

function PotMakerXL:addMsg(message)
	PotionMakerXLMsgWindow:SetHidden(false)
	PotionMakerXLMsgWindow:AddText(message)
	--CHAT_SYSTEM:AddMessage(message)
end

local function addButton(parent, name, callbackFunction, text, font, tooltipText, tooltipAlign, textureNormal, textureMouseOver, textureClicked, width, height, left, top, alignValue, alignControl, hideButton)
	--Add a button to an existing parent control
	--Abort needed?
	if  (parent == nil or name == nil or callbackFunction == nil
		or width <= 0 or height <= 0 )
		and (textureNormal == nil or text == nil) then
			return nil
	end
	local button
    --Does the button already exist?
    button = WINDOW_MANAGER:GetControlByName(name, "")
    if button == nil then
        --Button does not exist yet and it should be hidden? Abort here!
        if hideButton == true then return nil end
        --Create the button control at the parent
        button = WINDOW_MANAGER:CreateControl(name, parent, CT_BUTTON)
    end
    --Button was created?
    if button ~= nil then
        --Button should be hidden?
        if hideButton == false then
			local highlightColor = nil
            --Set the button's size
            button:SetDimensions(width, height)
            --Align the button
            if alignControl == nil then
                alignControl = parent
            end
            --SetAnchor(point, relativeTo, relativePoint, offsetX, offsetY)
			if alignValue == nil then alignValue = TOPLEFT end
            button:SetAnchor(alignValue, alignControl, alignValue, left, top)
            --Texture or text?
            if (text ~= nil) then
                --Text
				highlightColor = COLOR_KHRILLSELECT
                --Set the button's font
                if font == nil then
                    button:SetFont("ZoFontGameSmall")
                else
                    button:SetFont(font)
                end
                --Set the button's text
                button:SetText(text)
            else
                --Texture
                local texture
 
                --Check if texture exists
                texture = WINDOW_MANAGER:GetControlByName(name .. "Texture", "")
                if texture == nil then
                    --Create the texture for the button to hold the image
                    texture = WINDOW_MANAGER:CreateControl(name .. "Texture", button, CT_TEXTURE)
                end
                texture:SetAnchorFill()
                --Set the texture for normale state now
                texture:SetTexture(textureNormal)
                --Do we have seperate textures for the button states?
				if textureMouseOver == nil and textureClicked == nil then highlightColor = COLOR_KHRILLSELECT end
                button.upTexture      = textureNormal
                button.downTexture    = textureMouseOver or textureNormal
                button.clickedTexture = textureClicked or textureNormal
            end
            if tooltipAlign == nil then tooltipAlign = TOP end
            --Set a tooltip?
            if tooltipText ~= nil then
                if button:GetHandler("OnMouseEnter") == nil then button:SetHandler("OnMouseEnter", function(self)
                    self:GetChild(1):SetTexture(self.downTexture)
					if highlightColor ~= nil then self:GetChild(1):SetColor(HexToRGBA(highlightColor)) end
                    ZO_Tooltips_ShowTextTooltip(button, tooltipAlign, tooltipText)
					end)
				end
                if button:GetHandler("OnMouseExit") == nil then button:SetHandler("OnMouseExit", function(self)
                    self:GetChild(1):SetTexture(self.upTexture)
					if highlightColor ~= nil then self:GetChild(1):SetColor(HexToRGBA("FFFFFF00")) end
                    ZO_Tooltips_HideTextTooltip()
					end)
				end
            else
                if button:GetHandler("OnMouseEnter") == nil then button:SetHandler("OnMouseEnter", function(self)
                    self:GetChild(1):SetTexture(self.downTexture)
 					if highlightColor ~= nil then self:GetChild(1):SetColor(highlightColor) end
					end)
				end
                if button:GetHandler("OnMouseExit") == nil then button:SetHandler("OnMouseExit", function(self)
                    self:GetChild(1):SetTexture(self.upTexture)
 					if highlightColor ~= nil then self:GetChild(1):SetColor(HexToRGBA("FFFFFF00")) end
					end)
				end
            end
            --Set the callback function of the button
            if button:GetHandler("OnClicked") == nil then button:SetHandler("OnClicked", function(butn)
                callbackFunction()
				end)
			end
			if button:GetHandler("OnMouseDown") == nil then button:SetHandler("OnMouseDown", function(butn, ctrl, alt, shift, command)
				butn:GetChild(1):SetTexture(butn.clickedTexture)
				end)
			end
			--Show the button and make it react on mouse input
			button:SetHidden(false)
			button:SetMouseEnabled(true)
			--Return the button control
			return button
		else
			--Hide the button and make it not reacting on mouse input
			button:SetHidden(true)
			button:SetMouseEnabled(false)
		end
	else
		return nil
	end
end

function PotMakerXL:initVar(language)
PotMakerXL.allReagents = {
    [PME_Lang[language].reagentNames["nirnroot"]] = {
        [PME_Lang[language].traitNames["Ravage Health"]] = false,
        [PME_Lang[language].traitNames["Lower Spell Crit"]] = false,
        [PME_Lang[language].traitNames["Lower Weapon Crit"]] = false,
        [PME_Lang[language].traitNames["Invisible"]] = false
    },
    [PME_Lang[language].reagentNames["lady's smock"]] = {
        [PME_Lang[language].traitNames["Increase Spell Power"]] = false,
        [PME_Lang[language].traitNames["Restore Magicka"]] = false,
        [PME_Lang[language].traitNames["Lower Spell Resist"]] = false,
        [PME_Lang[language].traitNames["Spell Crit"]] = false
    },
    [PME_Lang[language].reagentNames["luminous russula"]] = {
        [PME_Lang[language].traitNames["Ravage Stamina"]] = false,
        [PME_Lang[language].traitNames["Lower Weapon Power"]] = false,
        [PME_Lang[language].traitNames["Restore Health"]] = false,
        [PME_Lang[language].traitNames["Reduce Speed"]] = false
    },
    [PME_Lang[language].reagentNames["violet coprinus"]] = {
        [PME_Lang[language].traitNames["Lower Spell Resist"]] = false,
        [PME_Lang[language].traitNames["Ravage Health"]] = false,
        [PME_Lang[language].traitNames["Increase Spell Power"]] = false,
        [PME_Lang[language].traitNames["Ravage Magicka"]] = false
    },
    [PME_Lang[language].reagentNames["dragonthorn"]] = {
        [PME_Lang[language].traitNames["Increase Weapon Power"]] = false,
        [PME_Lang[language].traitNames["Restore Stamina"]] = false,
        [PME_Lang[language].traitNames["Lower Armor"]] = false,
        [PME_Lang[language].traitNames["Weapon Crit"]] = false
    },
    [PME_Lang[language].reagentNames["blue entoloma"]] = {
        [PME_Lang[language].traitNames["Ravage Magicka"]] = false,
        [PME_Lang[language].traitNames["Lower Spell Power"]] = false,
        [PME_Lang[language].traitNames["Restore Health"]] = false,
        [PME_Lang[language].traitNames["Invisible"]] = false
    },
    [PME_Lang[language].reagentNames["stinkhorn"]] = {
        [PME_Lang[language].traitNames["Lower Armor"]] = false,
        [PME_Lang[language].traitNames["Ravage Health"]] = false,
        [PME_Lang[language].traitNames["Increase Weapon Power"]] = false,
        [PME_Lang[language].traitNames["Ravage Stamina"]] = false
    },
    [PME_Lang[language].reagentNames["corn flower"]] = {
        [PME_Lang[language].traitNames["Restore Magicka"]] = false,
        [PME_Lang[language].traitNames["Increase Spell Power"]] = false,
        [PME_Lang[language].traitNames["Ravage Health"]] = false,
        [PME_Lang[language].traitNames["Detection"]] = false
    },
    [PME_Lang[language].reagentNames["bugloss"]] = {
        [PME_Lang[language].traitNames["Increase Spell Resist"]] = false,
        [PME_Lang[language].traitNames["Restore Health"]] = false,
        [PME_Lang[language].traitNames["Lower Spell Power"]] = false,
        [PME_Lang[language].traitNames["Restore Magicka"]] = false
    },
    [PME_Lang[language].reagentNames["white cap"]] = {
        [PME_Lang[language].traitNames["Lower Spell Power"]] = false,
        [PME_Lang[language].traitNames["Ravage Magicka"]] = false,
        [PME_Lang[language].traitNames["Increase Spell Resist"]] = false,
        [PME_Lang[language].traitNames["Lower Spell Crit"]] = false
    },
    [PME_Lang[language].reagentNames["blessed thistle"]] = {
        [PME_Lang[language].traitNames["Restore Stamina"]] = false,
        [PME_Lang[language].traitNames["Increase Weapon Power"]] = false,
        [PME_Lang[language].traitNames["Ravage Health"]] = false,
        [PME_Lang[language].traitNames["Speed"]] = false
    },
    [PME_Lang[language].reagentNames["emetic russula"]] = {
        [PME_Lang[language].traitNames["Ravage Health"]] = false,
        [PME_Lang[language].traitNames["Ravage Magicka"]] = false,
        [PME_Lang[language].traitNames["Ravage Stamina"]] = false,
        [PME_Lang[language].traitNames["Stun"]] = false
    },
    [PME_Lang[language].reagentNames["columbine"]] = {
        [PME_Lang[language].traitNames["Restore Health"]] = false,
        [PME_Lang[language].traitNames["Restore Magicka"]] = false,
        [PME_Lang[language].traitNames["Restore Stamina"]] = false,
        [PME_Lang[language].traitNames["Unstoppable"]] = false
    },
    [PME_Lang[language].reagentNames["wormwood"]] = {
        [PME_Lang[language].traitNames["Weapon Crit"]] = false,
        [PME_Lang[language].traitNames["Reduce Speed"]] = false,
        [PME_Lang[language].traitNames["Detection"]] = false,
        [PME_Lang[language].traitNames["Unstoppable"]] = false
    },
    [PME_Lang[language].reagentNames["mountain flower"]] = {
        [PME_Lang[language].traitNames["Increase Armor"]] = false,
        [PME_Lang[language].traitNames["Restore Health"]] = false,
        [PME_Lang[language].traitNames["Lower Weapon Power"]] = false,
        [PME_Lang[language].traitNames["Restore Stamina"]] = false
    },
    [PME_Lang[language].reagentNames["namira's rot"]] = {
        [PME_Lang[language].traitNames["Spell Crit"]] = false,
        [PME_Lang[language].traitNames["Speed"]] = false,
        [PME_Lang[language].traitNames["Invisible"]] = false,
        [PME_Lang[language].traitNames["Unstoppable"]] = false
    },
    [PME_Lang[language].reagentNames["imp stool"]] = {
        [PME_Lang[language].traitNames["Lower Weapon Power"]] = false,
        [PME_Lang[language].traitNames["Increase Armor"]] = false,
        [PME_Lang[language].traitNames["Ravage Stamina"]] = false,
        [PME_Lang[language].traitNames["Lower Weapon Crit"]] = false
    },
    [PME_Lang[language].reagentNames["water hyacinth"]] = {
        [PME_Lang[language].traitNames["Restore Health"]] = false,
        [PME_Lang[language].traitNames["Weapon Crit"]] = false,
        [PME_Lang[language].traitNames["Spell Crit"]] = false,
        [PME_Lang[language].traitNames["Stun"]] = false
    },
	--2.4
    [PME_Lang[language].reagentNames["torchbug thorax"]] = {
		[PME_Lang[language].traitNames["Lower Armor"]] = false,
		[PME_Lang[language].traitNames["Lower Weapon Crit"]] = false,
		[PME_Lang[language].traitNames["Detection"]] = false,
		[PME_Lang[language].traitNames["Vitality"]] = false
    },
    [PME_Lang[language].reagentNames["beetle scuttle"]] = {
		[PME_Lang[language].traitNames["Lower Spell Resist"]] = false,
		[PME_Lang[language].traitNames["Increase Armor"]] = false,
		[PME_Lang[language].traitNames["Protection"]] = false,
		[PME_Lang[language].traitNames["Vitality"]] = false,
    },
    [PME_Lang[language].reagentNames["spider egg"]] = {
		[PME_Lang[language].traitNames["Reduce Speed"]] = false,
		[PME_Lang[language].traitNames["Invisible"]] = false,
		[PME_Lang[language].traitNames["Sustained Restore Health"]] = false,
		[PME_Lang[language].traitNames["Defile"]] = false,
	},
    [PME_Lang[language].reagentNames["butterfly wing"]] = {
		[PME_Lang[language].traitNames["Restore Health"]] = false,
		[PME_Lang[language].traitNames["Lower Spell Crit"]] = false,
		[PME_Lang[language].traitNames["Sustained Restore Health"]] = false,
		[PME_Lang[language].traitNames["Vitality"]] = false,
    },
    [PME_Lang[language].reagentNames["fleshfly larva"]] = {
		[PME_Lang[language].traitNames["Ravage Stamina"]] = false,
		[PME_Lang[language].traitNames["Vulnerability"]] = false,
		[PME_Lang[language].traitNames["Creeping Ravage Health"]] = false,
		[PME_Lang[language].traitNames["Vitality"]] = false,
    },
    [PME_Lang[language].reagentNames["scrib jelly"]] = {
		[PME_Lang[language].traitNames["Ravage Magicka"]] = false,
		[PME_Lang[language].traitNames["Speed"]] = false,
		[PME_Lang[language].traitNames["Vulnerability"]] = false,
		[PME_Lang[language].traitNames["Sustained Restore Health"]] = false,
    },
    [PME_Lang[language].reagentNames["nightshade"]] = {
		[PME_Lang[language].traitNames["Ravage Health"]] = false,
		[PME_Lang[language].traitNames["Protection"]] = false,
		[PME_Lang[language].traitNames["Creeping Ravage Health"]] = false,
		[PME_Lang[language].traitNames["Defile"]] = false,
    },
    [PME_Lang[language].reagentNames["mudcrab chitin"]] = {
		[PME_Lang[language].traitNames["Increase Spell Resist"]] = false,
		[PME_Lang[language].traitNames["Increase Armor"]] = false,
		[PME_Lang[language].traitNames["Protection"]] = false,
		[PME_Lang[language].traitNames["Defile"]] = false,
    },
}

PME_Lang[language].badTraitMatches = {
    [PME_Lang[language].traitNames["Restore Health"]] = PME_Lang[language].traitNames["Ravage Health"],
	[PME_Lang[language].traitNames["Ravage Health"]] = PME_Lang[language].traitNames["Ravage Health"],
	[PME_Lang[language].traitNames["Restore Magicka"]] = PME_Lang[language].traitNames["Ravage Magicka"],
	[PME_Lang[language].traitNames["Ravage Magicka"]] = PME_Lang[language].traitNames["Ravage Magicka"],
	[PME_Lang[language].traitNames["Restore Stamina"]] = PME_Lang[language].traitNames["Ravage Stamina"],
	[PME_Lang[language].traitNames["Ravage Stamina"]] = PME_Lang[language].traitNames["Ravage Stamina"],
	[PME_Lang[language].traitNames["Increase Weapon Power"]] = PME_Lang[language].traitNames["Lower Weapon Power"],
	[PME_Lang[language].traitNames["Lower Weapon Power"]] = PME_Lang[language].traitNames["Lower Weapon Power"],
	[PME_Lang[language].traitNames["Increase Spell Power"]] = PME_Lang[language].traitNames["Lower Spell Power"],
	[PME_Lang[language].traitNames["Lower Spell Power"]] = PME_Lang[language].traitNames["Lower Spell Power"],
	[PME_Lang[language].traitNames["Weapon Crit"]] = PME_Lang[language].traitNames["Lower Weapon Crit"],
	[PME_Lang[language].traitNames["Lower Weapon Crit"]] = PME_Lang[language].traitNames["Lower Weapon Crit"],
	[PME_Lang[language].traitNames["Spell Crit"]] = PME_Lang[language].traitNames["Lower Spell Crit"],
	[PME_Lang[language].traitNames["Lower Spell Crit"]] = PME_Lang[language].traitNames["Lower Spell Crit"],
	[PME_Lang[language].traitNames["Increase Armor"]] = PME_Lang[language].traitNames["Lower Armor"],
	[PME_Lang[language].traitNames["Lower Armor"]] = PME_Lang[language].traitNames["Lower Armor"],
	[PME_Lang[language].traitNames["Increase Spell Resist"]] = PME_Lang[language].traitNames["Lower Spell Resist"],
	[PME_Lang[language].traitNames["Lower Spell Resist"]] = PME_Lang[language].traitNames["Lower Spell Resist"],
	[PME_Lang[language].traitNames["Unstoppable"]] = PME_Lang[language].traitNames["Stun"],
	[PME_Lang[language].traitNames["Stun"]] = PME_Lang[language].traitNames["Stun"],
	[PME_Lang[language].traitNames["Speed"]] = PME_Lang[language].traitNames["Reduce Speed"],
	[PME_Lang[language].traitNames["Reduce Speed"]] = PME_Lang[language].traitNames["Reduce Speed"],
	[PME_Lang[language].traitNames["Invisible"]] = PME_Lang[language].traitNames["Detection"],
	[PME_Lang[language].traitNames["Detection"]] = PME_Lang[language].traitNames["Invisible"],
	--2.4
	[PME_Lang[language].traitNames["Protection"]] = PME_Lang[language].traitNames["Vulnerability"],
	[PME_Lang[language].traitNames["Sustained Restore Health"]] = PME_Lang[language].traitNames["Creeping Ravage Health"],
	[PME_Lang[language].traitNames["Vitality"]] = PME_Lang[language].traitNames["Defile"],
}

PME_Lang[language].oppositeTraits = {
	[PME_Lang[language].traitNames["Restore Health"]] = PME_Lang[language].traitNames["Ravage Health"],
	[PME_Lang[language].traitNames["Ravage Health"]] = PME_Lang[language].traitNames["Restore Health"],
	[PME_Lang[language].traitNames["Restore Magicka"]] = PME_Lang[language].traitNames["Ravage Magicka"],
	[PME_Lang[language].traitNames["Ravage Magicka"]] = PME_Lang[language].traitNames["Restore Magicka"],
	[PME_Lang[language].traitNames["Restore Stamina"]] = PME_Lang[language].traitNames["Ravage Stamina"],
	[PME_Lang[language].traitNames["Ravage Stamina"]] = PME_Lang[language].traitNames["Restore Stamina"],
	[PME_Lang[language].traitNames["Increase Weapon Power"]] = PME_Lang[language].traitNames["Lower Weapon Power"],
	[PME_Lang[language].traitNames["Lower Weapon Power"]] = PME_Lang[language].traitNames["Increase Weapon Power"],
	[PME_Lang[language].traitNames["Increase Spell Power"]] = PME_Lang[language].traitNames["Lower Spell Power"],
	[PME_Lang[language].traitNames["Lower Spell Power"]] = PME_Lang[language].traitNames["Increase Spell Power"],
	[PME_Lang[language].traitNames["Weapon Crit"]] = PME_Lang[language].traitNames["Lower Weapon Crit"],
	[PME_Lang[language].traitNames["Lower Weapon Crit"]] = PME_Lang[language].traitNames["Weapon Crit"],
	[PME_Lang[language].traitNames["Spell Crit"]] = PME_Lang[language].traitNames["Lower Spell Crit"],
	[PME_Lang[language].traitNames["Lower Spell Crit"]] = PME_Lang[language].traitNames["Spell Crit"],
	[PME_Lang[language].traitNames["Increase Armor"]] = PME_Lang[language].traitNames["Lower Armor"],
	[PME_Lang[language].traitNames["Lower Armor"]] = PME_Lang[language].traitNames["Increase Armor"],
	[PME_Lang[language].traitNames["Increase Spell Resist"]] = PME_Lang[language].traitNames["Lower Spell Resist"],
	[PME_Lang[language].traitNames["Lower Spell Resist"]] = PME_Lang[language].traitNames["Increase Spell Resist"],
	[PME_Lang[language].traitNames["Unstoppable"]] = PME_Lang[language].traitNames["Stun"],
	[PME_Lang[language].traitNames["Stun"]] = PME_Lang[language].traitNames["Unstoppable"],
	[PME_Lang[language].traitNames["Speed"]] = PME_Lang[language].traitNames["Reduce Speed"],
	[PME_Lang[language].traitNames["Reduce Speed"]] = PME_Lang[language].traitNames["Speed"],
	[PME_Lang[language].traitNames["Invisible"]] = PME_Lang[language].traitNames["Detection"],
	[PME_Lang[language].traitNames["Detection"]] = PME_Lang[language].traitNames["Invisible"],
	--2.4
	[PME_Lang[language].traitNames["Vitality"]] = PME_Lang[language].traitNames["Defile"],
	[PME_Lang[language].traitNames["Sustained Restore Health"]] = PME_Lang[language].traitNames["Creeping Ravage Health"],
	[PME_Lang[language].traitNames["Protection"]] = PME_Lang[language].traitNames["Vulnerability"],
	[PME_Lang[language].traitNames["Creeping Ravage Health"]] = PME_Lang[language].traitNames["Sustained Restore Health"],
	[PME_Lang[language].traitNames["Defile"]] = PME_Lang[language].traitNames["Vitality"],
	[PME_Lang[language].traitNames["Vulnerability"]] = PME_Lang[language].traitNames["Protection"],
}

PME_Lang[language].checkBoxNames = {
	["Restore Health"] = "PotionMakerXL".. PME_Lang[language].traitNames["Restore Health"]:gsub(" ", "") .."CheckBox",
	["Ravage Health"] = "PotionMakerXL".. PME_Lang[language].traitNames["Ravage Health"]:gsub(" ", "") .."CheckBox",
	["Restore Magicka"] = "PotionMakerXL".. PME_Lang[language].traitNames["Restore Magicka"]:gsub(" ", "") .."CheckBox",
	["Ravage Magicka"] = "PotionMakerXL".. PME_Lang[language].traitNames["Ravage Magicka"]:gsub(" ", "") .."CheckBox",
	["Restore Stamina"] = "PotionMakerXL".. PME_Lang[language].traitNames["Restore Stamina"]:gsub(" ", "") .."CheckBox",
	["Ravage Stamina"] = "PotionMakerXL".. PME_Lang[language].traitNames["Ravage Stamina"]:gsub(" ", "") .."CheckBox",
	["Increase Weapon Power"] = "PotionMakerXL".. PME_Lang[language].traitNames["Increase Weapon Power"]:gsub(" ", "") .."CheckBox",
	["Lower Weapon Power"] = "PotionMakerXL".. PME_Lang[language].traitNames["Lower Weapon Power"]:gsub(" ", "") .."CheckBox",
	["Increase Spell Power"] = "PotionMakerXL".. PME_Lang[language].traitNames["Increase Spell Power"]:gsub(" ", "") .."CheckBox",
	["Lower Spell Power"] = "PotionMakerXL".. PME_Lang[language].traitNames["Lower Spell Power"]:gsub(" ", "") .."CheckBox",
	["Weapon Crit"] = "PotionMakerXL".. PME_Lang[language].traitNames["Weapon Crit"]:gsub(" ", "") .."CheckBox",
	["Lower Weapon Crit"] = "PotionMakerXL".. PME_Lang[language].traitNames["Lower Weapon Crit"]:gsub(" ", "") .."CheckBox",
	["Spell Crit"] = "PotionMakerXL".. PME_Lang[language].traitNames["Spell Crit"]:gsub(" ", "") .."CheckBox",
	["Lower Spell Crit"] = "PotionMakerXL".. PME_Lang[language].traitNames["Lower Spell Crit"]:gsub(" ", "") .."CheckBox",
	["Increase Armor"] = "PotionMakerXL".. PME_Lang[language].traitNames["Increase Armor"]:gsub(" ", "") .."CheckBox",
	["Lower Armor"] = "PotionMakerXL".. PME_Lang[language].traitNames["Lower Armor"]:gsub(" ", "") .."CheckBox",
	["Increase Spell Resist"] = "PotionMakerXL".. PME_Lang[language].traitNames["Increase Spell Resist"]:gsub(" ", "") .."CheckBox",
	["Lower Spell Resist"] = "PotionMakerXL".. PME_Lang[language].traitNames["Lower Spell Resist"]:gsub(" ", "") .."CheckBox",
	["Unstoppable"] = "PotionMakerXL".. PME_Lang[language].traitNames["Unstoppable"]:gsub(" ", "") .."CheckBox",
	["Stun"] = "PotionMakerXL".. PME_Lang[language].traitNames["Stun"]:gsub(" ", "") .."CheckBox",
	["Speed"] = "PotionMakerXL".. PME_Lang[language].traitNames["Speed"]:gsub(" ", "") .."CheckBox",
	["Reduce Speed"] = "PotionMakerXL".. PME_Lang[language].traitNames["Reduce Speed"]:gsub(" ", "") .."CheckBox",
	["Invisible"] = "PotionMakerXL".. PME_Lang[language].traitNames["Invisible"]:gsub(" ", "") .."CheckBox",
	["Detection"] = "PotionMakerXL".. PME_Lang[language].traitNames["Detection"]:gsub(" ", "") .."CheckBox",
	--2.4
	["Vitality"] = "PotionMakerXL".. PME_Lang[language].traitNames["Vitality"]:gsub(" ", "") .."CheckBox",
	["Sustained Restore Health"] = "PotionMakerXL".. PME_Lang[language].traitNames["Sustained Restore Health"]:gsub(" ", "") .."CheckBox",
	["Protection"] = "PotionMakerXL".. PME_Lang[language].traitNames["Protection"]:gsub(" ", "") .."CheckBox",
	["Creeping Ravage Health"] = "PotionMakerXL".. PME_Lang[language].traitNames["Creeping Ravage Health"]:gsub(" ", "") .."CheckBox",
	["Defile"] = "PotionMakerXL".. PME_Lang[language].traitNames["Defile"]:gsub(" ", "") .."CheckBox",
	["Vulnerability"] = "PotionMakerXL".. PME_Lang[language].traitNames["Vulnerability"]:gsub(" ", "") .."CheckBox",
}
end

function PotMakerXL.DEC_HEX(IN)
    local B,K,OUT,I,D=16,"0123456789abcdef","",0
    while IN>0 do
        I=I+1
        IN,D=math.floor(IN/B),math.mod(IN,B)+1
        OUT=string.sub(K,D,D)..OUT
    end
    if OUT:len() == 0 then
        OUT = "=="
    elseif OUT:len() == 1 then
        OUT = "0" .. OUT
    end
    return OUT
end

PotMakerXL.Ingredient = {
    name = "",
    qualityColor = "ffffff",
	level = 0,
	icon = TEXTURE_REAGENTUNKNOWN,
    traits = {}, --name = true/false
	iconTraits = {},
    bag = 0,
    slot = 0,
    traitNames = {},
    badTraitMatches = {},
    oppositeTraits = {}
}

function PotMakerXL.Ingredient:matchIngredient(passiveIngredient)
    local matched = {}
    for traitName, known in pairs(self.traits) do
        local trait = traitName
        local double = false
        if trait ~= nil then
            local lastCharOfSelfName = string.sub(trait, -1)
            if lastCharOfSelfName == "-" or lastCharOfSelfName == "+" then
                double = true
                trait = trait:sub(1, -2)
            end
        else
            return matched
        end
        local doubleInserted = false
        for passiveTrait, passiveKnown in pairs(passiveIngredient.traits) do
            if passiveTrait == nil then
                return matched
            end
            if trait == passiveTrait then
                if PME_Lang[language].badTraitMatches[trait] == passiveTrait then
                    if double then
                        table.insert(matched, trait .. "/")
                        doubleInserted = true
                    else
                        table.insert(matched, trait .. "-")
                    end
                else
                    if double then
                        table.insert(matched, trait .. "*")
                        doubleInserted = true
                    else
                        table.insert(matched, trait .. "+")
                    end
                end
            elseif double and PME_Lang[language].oppositeTraits[trait] == passiveTrait then
                doubleInserted = true
            end
        end
        if double and not doubleInserted then
            table.insert(matched, traitName)
        end
    end
--d(matched)
--d("----")
    return matched
end

function PotMakerXL.Ingredient:new (o)
    o = o or {}   -- create object if user does not provide one
    setmetatable(o, self)
    self.__index = self
    local newTraits = {}
    if PotionMakerSavedVariables.useUnknown or PotionMakerSavedVariables.useMissing then
        newTraits = PotMakerXL.allReagents[o.name]
        if newTraits == nil then
            newTraits = {}
        end
    end
    -- scrub nil values, other are known trait
    for _, v in pairs(o.traits) do
		if v ~= nil then
            newTraits[v] = true
        end
    end
	o.traits = newTraits
    return o
end

function PotMakerXL.Ingredient.showTip(resultButton, state)
	local control=WINDOW_MANAGER:GetControlByName("PotionMakerXLSelectedReagent")
	if state then
		control:SetText(resultButton.reagent.name)
		if PotionMakerSavedVariables.reagentLevelColor then
			control:SetColor(HexToRGBA(resultButton.reagent.qualityColor.."FF"))
		else
			control:SetColor(HexToRGBA(COLOR_KHRILLSELECT))
		end
	else
		control:SetText("")
	end
end
function PotMakerXL.Ingredient.select(resultButton)
    -- if resultButton:GetNamedChild("Text") then
		-- --solvent => deselect all
		-- for _, control in pairs(PotMakerXL.SolventFilterControls) do
			-- if control.text ~= resultButton.text then
				-- control:GetNamedChild("Outline"):SetHidden(true)
				-- if control:GetNamedChild("Text") then control:GetNamedChild("Text"):SetColor(GetInterfaceColor(INTERFACE_COLOR_TYPE_TEXT_COLORS,INTERFACE_TEXT_COLOR_NORMAL)) end
			-- end
		-- end
    -- end
	if resultButton:GetNamedChild("Outline"):IsControlHidden() then
		resultButton:GetNamedChild("Outline"):SetColor(HexToRGBA("FF6A00FF"))
		resultButton:GetNamedChild("Outline"):SetTexture(TEXTURE_HIGHLIGHT)
		resultButton:GetNamedChild("Outline"):SetHidden(false)
		if resultButton:GetNamedChild("Text") then resultButton:GetNamedChild("Text"):SetColor(HexToRGBA("FF6A00FF")) end
	else
		resultButton:GetNamedChild("Outline"):SetHidden(true)
		if resultButton:GetNamedChild("Text")then resultButton:GetNamedChild("Text"):SetColor(GetInterfaceColor(INTERFACE_COLOR_TYPE_TEXT_COLORS,INTERFACE_TEXT_COLOR_NORMAL)) end
	end



end


PotMakerXL.Potion = {
    name = "",
    ingredients = {},
	solvent = nil,
    traits = {},
    qualityColor = "ffffff",
	quantity = 0
}

function PotMakerXL.Potion:new (o)
    o = o or {}   -- create object if user does not provide one
    setmetatable(o, self)
    self.__index = self
    for _, potion in pairs(PotMakerXL.doablePotions) do
        if o:hasSameIngredients(potion) then
			if o.solvent == nil or potion.solvent == nil or o.solvent.name == potion.solvent.name then
				return nil
			end
        end
    end

    if o.solvent ~= nil then
        if o.ingredients[3] ~= nil then
            local name, _, _, _, _, _, _, quality = GetAlchemyResultingItemInfo(
            o.solvent.bag,
            o.solvent.slot,
            o.ingredients[1].bag, 
            o.ingredients[1].slot, 
            o.ingredients[2].bag, 
            o.ingredients[2].slot, 
            o.ingredients[3].bag, 
            o.ingredients[3].slot)
            local qualityColor = GetItemQualityColor(quality)
            o.qualityColor = PotMakerXL.DEC_HEX(math.floor(((qualityColor["r"]) * 256) - 0.5)) .. PotMakerXL.DEC_HEX(math.floor(((qualityColor["g"]) * 256) - 0.5)) .. PotMakerXL.DEC_HEX(math.floor(((qualityColor["b"]) * 256) - 0.5))
            o.name = name
        else
            local name, _, _, _, _, _, _, quality = GetAlchemyResultingItemInfo(
            o.solvent.bag,
            o.solvent.slot,
            o.ingredients[1].bag, 
            o.ingredients[1].slot, 
            o.ingredients[2].bag, 
            o.ingredients[2].slot)
            local qualityColor = GetItemQualityColor(quality)
            o.qualityColor = PotMakerXL.DEC_HEX(math.floor(((qualityColor["r"]) * 256) - 0.5)) .. PotMakerXL.DEC_HEX(math.floor(((qualityColor["g"]) * 256) - 0.5)) .. PotMakerXL.DEC_HEX(math.floor(((qualityColor["b"]) * 256) - 0.5))
            o.name = name
        end
    end
    return o
end

function PotMakerXL.Potion:conformsToSearch(searchTerms)
	-- if no name then not conform
	if self.solvent ~= nil and not(PotionMakerSavedVariables.useUnknown or PotionMakerSavedVariables.useMissing) then return false end
--	if self.solvent ~= nil and self.name == "" then return false end
--	if PotMakerXL.usedSolvent ~= nil and self.name == "" then return false end
	
	-- check name contains
	if PotMakerXL.nameContainsFilter ~= "" and string.find(self.name:lower(), PotMakerXL.nameContainsFilter:lower()) == nil then return false end
	
    searchTerms = searchTerms or {}
    local mustHaves = {}
    
    -- local searchTermsExist = false
    -- for _, _ in pairs(searchTerms) do
        -- searchTermsExist = true
        -- break
    -- end
    local searchTermsExist = searchTerms ~= {}
    
    local unknownTrait = false
    
    if searchTermsExist or PotionMakerSavedVariables.training then
        for _, trait in pairs(self.traits) do
            local traitName = ""
            local lastCharOfSelfName = string.sub(trait, -1)
            -- if lastCharOfSelfName ~= nil
            if lastCharOfSelfName == "-" or lastCharOfSelfName == "/" then
                traitName = PotMakerXL.stripTrailingJunk(trait:sub(1, -2))
                if PotionMakerSavedVariables.training then
                    for _, ingredient in pairs(self.ingredients) do
                        for trait2, known in pairs(ingredient.traits) do
                            if traitName == trait2 and not known then
                                unknownTrait = true
                                break
                            end
                        end
                    end
                end
                if searchTerms[traitName] ~= nil and not searchTerms[traitName] then
                    return false
                end
            elseif lastCharOfSelfName == "+" or lastCharOfSelfName == "*" then
                traitName = PotMakerXL.stripTrailingJunk(trait:sub(1, -2))
                if PotionMakerSavedVariables.training then
                    for _, ingredient in pairs(self.ingredients) do
                        for trait2, known in pairs(ingredient.traits) do
                            if traitName == trait2 and not known then
                                unknownTrait = true
                                break
                            end
                        end
                    end
                end
                if searchTerms[traitName] ~= nil and searchTerms[traitName] then
                    mustHaves[traitName] = true
                end
            end
        end
        for k, v in pairs(searchTerms) do
            if v and mustHaves[k] == nil then
                return false
            end
        end
    end
    if not PotionMakerSavedVariables.training or (PotionMakerSavedVariables.training and unknownTrait) then
        return true
    end
    return false
end

function PotMakerXL.Potion:hasSameIngredients(potion)
    if #self.ingredients ~= #potion.ingredients then
        return false
    end
    for _, ingredient1 in pairs(self.ingredients) do
        local ingredient1InPotion = false
        for _, ingredient2 in pairs(potion.ingredients) do
            if ingredient1.name == ingredient2.name then
                ingredient1InPotion = true
                break
            end
        end
        if not ingredient1InPotion then
            return false
        end
    end
    return true
end

-- CraftAlchemyItem is not working.
-- I get the error message "Alchemical reaction yielded no results"
-- function PotMakerXL.Potion.create(resultButton)
    -- local control = WINDOW_MANAGER:GetControlByName(resultButton:GetParent():GetName() .. "CreateButton")
    -- control:SetHidden(true)
    -- control = WINDOW_MANAGER:GetControlByName(resultButton:GetParent():GetName() .. "ShowButton")
    -- control:SetHidden(false)
    -- local potion = nil
    -- local ingredientsString = ""

    -- for _, pot in pairs(PotMakerXL.doablePotions) do
        -- ingredientsString = ""
        -- for i = 1, #pot.ingredients do
            -- ingredientsString = ingredientsString .. "|c" .. pot.ingredients[i].name .. ":|r and "
        -- end
        -- ingredientsString = ingredientsString:sub(1, -6)
        -- if resultButton:GetParent():GetText() == ingredientsString then
            -- potion = pot
        -- end
    -- end
    
    -- if #potion.ingredients > 2 then
        -- CraftAlchemyItem(PotMakerXL.usedSolvent.bag, PotMakerXL.usedSolvent.index, potion.ingredients[1].bag, potion.ingredients[1].slot, potion.ingredients[2].bag, potion.ingredients[2].slot, potion.ingredients[3].bag, potion.ingredients[3].slot)
    -- else
        -- CraftAlchemyItem(PotMakerXL.usedSolvent.bag, PotMakerXL.usedSolvent.index, potion.ingredients[1].bag, potion.ingredients[1].slot, potion.ingredients[2].bag, potion.ingredients[2].slot)
    -- end
-- end

function PotMakerXL.Potion.get(resultButton)
    local ingredientsString = ""
    for _, pot in pairs(PotMakerXL.doablePotions) do
        local ingredients = pot.ingredients
        table.sort(ingredients, function (a, b) return string.lower(a.name) < string.lower(b.name) end)
        
		ingredientsString = PotMakerXL.Potion.getIngredientString(pot)
		-- check
		if resultButton:GetParent():GetText():gsub(" ", "") == ingredientsString:gsub(" ", "") then
			--same ingredients
			local potionString = WINDOW_MANAGER:GetControlByName(resultButton:GetParent():GetName().."Potion"):GetText()
			if potionString == PotMakerXL.Potion:getPotionNameString(pot) then -- or potionString == PME_Lang[language].need_solvent then
				-- and same potion
				return pot
			end
        end
    end
end
function PotMakerXL.Potion.show(resultButton)
    local potion = PotMakerXL.Potion.get(resultButton)
	local isMissing = true
    -- d(#potion.ingredients)
	
    if PotMakerXL.atAlchemyStation and not PotionMakerSavedVariables.useMissing and ((not PotionMakerSavedVariables.fakeThirdSlot) or #potion.ingredients < 3) then
        ALCHEMY:ClearSelections()
		isMissing = false
        if potion.solvent ~= nil then --PotMakerXL.usedSolvent ~= nil then
            ALCHEMY:AddItemToCraft(potion.solvent.bag, potion.solvent.slot)
--            ALCHEMY:AddItemToCraft(PotMakerXL.usedSolvent.bag, PotMakerXL.usedSolvent.slot)
        end
        for k, v in pairs(potion.ingredients) do
            -- ingredients[string.lower(v.name)] = v
			if v.bag ~= nil and v.slot ~= nil then
				ALCHEMY:AddItemToCraft(v.bag, v.slot)
			else
				isMissing = true
			end
        end

    end
	if isMissing then
		PotionMakerXLMsgWindow:ClearAnchors()
		PotionMakerXLMsgWindow:SetAnchor(TOPLEFT, PotionMakerXL, TOPRIGHT, 0,0)
		PotionMakerXLMsgWindow:ClearText()
--		PotMakerXL:addMsg("_________________________")
        if potion.name ~= "" then
            PotMakerXL:addMsg("|c" .. potion.qualityColor .. PotMakerXL.stripTrailingJunk(potion.name) .. "|r")
        end

        PotMakerXL:addMsg(PME_Lang[language].made_with)
        for i = 1, #potion.ingredients do
            local amount = PotMakerXL.Inventory.reagents[potion.ingredients[i]]
            PotMakerXL:addMsg("|c" .. potion.ingredients[i].qualityColor .. potion.ingredients[i].name .. " (" .. amount .. ")|r")
        end
		PotMakerXL:addMsg(PME_Lang[language].has_traits)
        for _, v in pairs(potion.traits) do
            if v ~= nil and string.sub(v, -1) == "-" then
                PotMakerXL:addMsg("|cff7f50" .. v:sub(1, -2) .. "|r")
            elseif v ~= nil and string.sub(v, -1) == "/" then
                PotMakerXL:addMsg("|cff0000" .. v:sub(1, -2) .. "|r")
            elseif v ~= nil and string.sub(v, -1) == "+" then
                PotMakerXL:addMsg("|c9acd32" .. v:sub(1, -2) .. "|r")
            elseif v ~= nil and string.sub(v, -1) == "*" then
                PotMakerXL:addMsg("|c228b22" .. v:sub(1, -2) .. "|r")
            end
        end
		PotMakerXL:addMsg("___________________________")		
	end
end
function PotMakerXL.Potion.getIngredientString(potion)
	local ingredientsString = ""
	for j = 1, #potion.ingredients do
		if PotionMakerSavedVariables.reagentLevelColor then
			ingredientsString = ingredientsString .. "|c"..potion.ingredients[j].qualityColor..PotMakerXL.stripTrailingJunk(potion.ingredients[j].name).."|r".. PME_Lang[language].annd
		else
			ingredientsString = ingredientsString .. PotMakerXL.stripTrailingJunk(potion.ingredients[j].name).. PME_Lang[language].annd
		end
	end
	ingredientsString = ingredientsString:sub(1, -string.len(PME_Lang[language].annd)-1)
	ingredientsString = ingredientsString .. " (|c"..COLOR_KHRILLSELECT..potion.quantity.."|r)"
	return ingredientsString
end
function PotMakerXL.Potion:getPotionNameString(potion)
--	return zo_strformat(SI_UNIT_NAME, "|c"..potion.qualityColor..potion.name.."|r")
	if potion.name == "" then
		if potion.solvent == nil then
			return "|c"..COLOR_DISABLED.."("..PME_Lang[language].need_solvent..")|r"
		else
			return "|c"..COLOR_DISABLED.."("..zo_strformat(SI_ALCHEMY_UNKNOWN_RESULT,GetString(SI_ITEM_FORMAT_STR_POTION))..")|r"
		end
	else
		return zo_strformat(SI_UNIT_NAME, potion.name)
	end
end

PotMakerXL.Inventory = {
    reagents = {},
    solvents = {}
}

function PotMakerXL.work()
    -- d(PotMakerXL.Inventory.reagents["stinkhorn"])
    -- for k, v in pairs (PotMakerXL.Inventory.reagents) do
        -- d(k .. " : " .. v)
    -- end
    -- for k, v in pairs (PotMakerXL.Inventory.solvents) do
        -- d(k .. " : " .. v)
    -- end
    -- for k, v in pairs(traits) do
        -- d(k)
    -- end
    d(PME_Lang[language])
end

function PotMakerXL:toggleBag(button)
	-- // BagButton selected
	PotMakerXL.BagMode = not PotMakerXL.BagMode
	if not PotMakerXL.BagMode then
		WINDOW_MANAGER:GetControlByName("PotionMakerXLBagButtonTexture"):SetColor(HexToRGBA(COLOR_DISABLED))
	else
		WINDOW_MANAGER:GetControlByName("PotionMakerXLBagButtonTexture"):SetColor(HexToRGBA(COLOR_KHRILLSELECT))
	end
	PotMakerXL.addStuffToInventory()
    PotMakerXL.updateControls()
end
function PotMakerXL:toggleBank(button)
	-- // BankButton selected
	PotMakerXL.BankMode = not PotMakerXL.BankMode
	if not PotMakerXL.BankMode then
		WINDOW_MANAGER:GetControlByName("PotionMakerXLBankButtonTexture"):SetColor(HexToRGBA(COLOR_DISABLED))
	else
		WINDOW_MANAGER:GetControlByName("PotionMakerXLBankButtonTexture"):SetColor(HexToRGBA(COLOR_KHRILLSELECT))
	end
	PotMakerXL.addStuffToInventory()
    PotMakerXL.updateControls()
end
function PotMakerXL:toggleEnableBtn(value)
	PotionMakerSavedVariables.enableButton = value
	--need to clear anchor of the menu bar so the button won't move the whole bar to the left!
 --   ZO_AlchemyTopLevelModeMenuBar:ClearAnchors()
    --Create and add the button with textures, tooltip and callback function
	--parent, name, callbackFunction, text, font, tooltipText, tooltipAlign, textureNormal, textureMouseOver, textureClicked, width, height, left, top, alignValue, alignControl, hideButton
    addButton(ZO_AlchemyTopLevelModeMenu, "ZO_AlchemyTopLevelModeMenuButtonShowPotMakerXL", PotMakerXL_toggleByKey, nil, nil, "|c"..COLOR_KHRILLSELECT..PME_Lang[language].SI_BINDING_NAME_PMETOGGLE.." "..PotMakerXL.name.."|r", TOP, TEXTURE_ENABLEBUTTON, nil, nil, 32, 32, 50, 10, TOPLEFT, ZO_AlchemyTopLevelModeMenu, not PotionMakerSavedVariables.enableButton)
end
function PotMakerXL_toggleByKey()
	PotMakerXL:toggleByKey()
end
function PotMakerXL:toggleByKey()
	-- show/hide by keybind
	if PotionMakerXL:IsHidden() and PotionMakerXLOutput:IsHidden() then
--		SetGameCameraUIMode(true)
		PotMakerXL.atAlchemyStation = (GetInteractionType() == INTERACTION_CRAFT and GetCraftingInteractionType() == CRAFTING_TYPE_ALCHEMY)
		PotMakerXL.doAlchemy()
	else
		PotMakerXL.close()
	end
end

function PotMakerXL.addAllStuffToInventory()
    for reagent, traits in pairs(PotMakerXL.allReagents) do
        -- local ingredientTraits = {}
		-- for k, v in pairs(traits) do
            -- table.insert(ingredientTraits, k)
        -- end
        -- local item = PotMakerXL.Ingredient:new{name = PotMakerXL.stripTrailingJunk(reagent), traits = ingredientTraits, iconTraits={}, bag = nil, slot = nil}
        local item = PotMakerXL.Ingredient:new{name = PotMakerXL.stripTrailingJunk(reagent), traits = {}, iconTraits={}, bag = nil, slot = nil}
--         d(item)
        PotMakerXL.Inventory.reagents[item] = 0
    end
end

function PotMakerXL.addStuffToInventoryForBag(bagId)
    local bagSlots = GetBagSize(bagId)
	local slotIndex = ZO_GetNextBagSlotIndex(bagId, nil)
	while slotIndex do
    --for slotIndex = 0, bagSlots do
		local itemType = GetItemType(bagId, slotIndex)
        if ZO_Alchemy_IsAlchemyItem(bagId, slotIndex) then
		--if itemType == ITEMTYPE_REAGENT or itemType == ITEMTYPE_POTION_BASE then 
            local icon, stack, _, meetsUsageRequirement, _, _, _, quality = GetItemInfo(bagId, slotIndex)
            local name = string.lower(GetItemName(bagId, slotIndex))
			local level = GetItemLevel(bagId, slotIndex)
			--adapt level from game
			if level == 53 then level = "*10" 
			elseif level == 59 then level = "*50"
			elseif level == 67 then level = "*100"
			elseif level == 74 then level = "*150"
			else
				level = level -1
				if level < 10 then level = "0"..level end
			end
--		d(itemType,name,level)
            if itemType == ITEMTYPE_REAGENT then -- Reagents
--                local trait1, icon1, icon1b, oppos1, trait2, icon2, icon2b, oppos2, trait3, icon3, icon3b, oppos3, trait4, icon4, icon4b, oppos4 = GetAlchemyItemTraits(bagId, slotIndex)
                local trait1, icon1, icon1b, oppos1, iconC1, trait2, icon2, icon2b, oppos2, iconC2, trait3, icon3, icon3b, oppos3, iconC3, trait4, icon4, icon4b, oppos4, iconC4 = GetAlchemyItemTraits(bagId, slotIndex)
--		d("--"..name,trait1, trait2, trait3, trait4)
				local iconTraits = {} 
				if trait1 ~= nil then iconTraits[trait1]=icon1 end
				if trait2 ~= nil then iconTraits[trait2]=icon2 end
				if trait3 ~= nil then iconTraits[trait3]=icon3 end
				if trait4 ~= nil then iconTraits[trait4]=icon4 end
                local item = PotMakerXL.Ingredient:new{name = PotMakerXL.stripTrailingJunk(name), icon=icon, level=level, traits = {trait1, trait2, trait3, trait4}, iconTraits=iconTraits, bag = bagId, slot = slotIndex}
                local qualityColor = GetItemQualityColor(quality)
                item.qualityColor = PotMakerXL.DEC_HEX(math.floor(((qualityColor["r"]) * 256) - 0.5)) .. PotMakerXL.DEC_HEX(math.floor(((qualityColor["g"]) * 256) - 0.5)) .. PotMakerXL.DEC_HEX(math.floor(((qualityColor["b"]) * 256) - 0.5))
                local itemAlreadyInInventory = nil
                for k, v in pairs(PotMakerXL.Inventory.reagents) do
                    if k.name == item.name then
						k.icon = icon
						k.level = level
						k.iconTraits = iconTraits
						k.traits = item.traits
						k.bagId = bagId
						k.slotIndex = slotIndex
                        itemAlreadyInInventory = k
                        break
                    end
                end
                if itemAlreadyInInventory ~= nil then
                    PotMakerXL.Inventory.reagents[itemAlreadyInInventory] = PotMakerXL.Inventory.reagents[itemAlreadyInInventory] + stack
                else
                    PotMakerXL.Inventory.reagents[item] = stack
                end
            elseif meetsUsageRequirement and itemType == ITEMTYPE_POTION_BASE then -- Potion Solvents
                local item = PotMakerXL.Ingredient:new{name = PotMakerXL.stripTrailingJunk(name), icon=icon, level=level, bag = bagId, slot = slotIndex}
                local qualityColor = GetItemQualityColor(quality)
                item.qualityColor = PotMakerXL.DEC_HEX(math.floor(((qualityColor["r"]) * 256) - 0.5)) .. PotMakerXL.DEC_HEX(math.floor(((qualityColor["g"]) * 256) - 0.5)) .. PotMakerXL.DEC_HEX(math.floor(((qualityColor["b"]) * 256) - 0.5))
                local itemAlreadyInInventory = nil
                for k, v in pairs(PotMakerXL.Inventory.solvents) do
                    if k.name == item.name then
                        itemAlreadyInInventory = k
                        break
                    end
                end
                if itemAlreadyInInventory ~= nil then
                    PotMakerXL.Inventory.solvents[itemAlreadyInInventory] = PotMakerXL.Inventory.solvents[itemAlreadyInInventory] + stack
                else
                    PotMakerXL.Inventory.solvents[item] = stack
                end
            end
        end
		slotIndex = ZO_GetNextBagSlotIndex(bagId, slotIndex)
    end
end

function PotMakerXL.addStuffToInventory()
	PotMakerXL.Inventory = {
		reagents = {},
		solvents = {}
	}
    if PotionMakerSavedVariables.useMissing then
        PotMakerXL.addAllStuffToInventory()
    end
    if PotMakerXL.BagMode then
		PotMakerXL.addStuffToInventoryForBag(BAG_BACKPACK) -- backpack
		if HasCraftBagAccess() then PotMakerXL.addStuffToInventoryForBag(BAG_VIRTUAL) end --craftbag
	end 
    if PotMakerXL.BankMode then PotMakerXL.addStuffToInventoryForBag(BAG_BANK) end -- bank
    -- if PotMakerXL.useGuildBank
    -- PotMakerXL.savedVariables.inventory.reagents = {}
    -- for k, v in pairs(PotMakerXL.Inventory.reagents) do
        -- if v then
            -- PotMakerXL.savedVariables.inventory.reagents[k.name] = k.traits
        -- end
    -- end
    -- d(PotMakerXL.data.savedVariables)
    --addStuffToBag(3) -- guild bank
end

function PotMakerXL.createCombinationIngredient(ingredient1, ingredient2, matches)
    local combinationTraits = matches
    for trait1, known1 in pairs(ingredient1.traits) do
        local matched = false
        for _, match1 in pairs(matches) do
			if string.find(match1, trait1) == 1 then
--            if match1:sub(1, -2) == trait1 then
                matched = true
                break
            end
        end
        local oppositeTraitInIngredient2 = false
        for trait2, known2 in pairs(ingredient2.traits) do
           if PME_Lang[language].oppositeTraits[trait1] == trait2 then
                oppositeTraitInIngredient2 = true
				break
            end
        end
        if not matched and not oppositeTraitInIngredient2 then
            table.insert(combinationTraits, trait1)
        end
    end
    for trait2, known2 in pairs(ingredient2.traits) do
        local matched = false
        for _, match1 in pairs(matches) do
			if string.find(match1, trait2) == 1 then
 --           if match1:sub(1, -2) == trait2 then
                matched = true
                break
            end
        end
        local oppositeTraitInIngredient1 = false
        for trait1, known1 in pairs(ingredient1.traits) do
            if PME_Lang[language].oppositeTraits[trait2] == trait1 then
                oppositeTraitInIngredient1 = true
				break
            end
        end

        if not matched and not oppositeTraitInIngredient1 then
            table.insert(combinationTraits, trait2)
        end
    end
    
    return PotMakerXL.Ingredient:new{name = PotMakerXL.stripTrailingJunk(ingredient1.name) .. " & " .. PotMakerXL.stripTrailingJunk(ingredient2.name), traits = combinationTraits}
end

function PotMakerXL.findDoablePotions(searchTerms, searchSolvent, searchReagent)
	local currentAmount, currentSolvent
    searchTerms = searchTerms or {}
	searchSolvent = searchSolvent or {}
	searchReagent = searchReagent or {}
--d("searchSolvent[count]="..tostring(searchSolvent["count"]))
    for ingredient1, amount1 in pairs(PotMakerXL.Inventory.reagents) do
        if ingredient1 ~= nil and (searchReagent["count"] == 0 or (searchReagent[ingredient1.name] ~= nil and searchReagent[ingredient1.name])) then
            for ingredient2, amount2 in pairs(PotMakerXL.Inventory.reagents) do
--	d("--loop "..ingredient1.name..","..ingredient2.name)
                if ingredient2 ~= nil and ingredient1 ~= ingredient2 and (not PotMakerXL.onlyReagentFilter or searchReagent["count"] == 0 or (searchReagent[ingredient2.name] ~= nil and searchReagent[ingredient2.name])) then
                    local checkMatches = ingredient1:matchIngredient(ingredient2)
--	d(#checkMatches)
                    if #checkMatches > 0 then
                        local combinationIngredient = PotMakerXL.createCombinationIngredient(ingredient1, ingredient2, checkMatches)
						-- for each selected solvent we make a potion
						for solvent, amount in pairs(PotMakerXL.Inventory.solvents) do
--	d("searchSolvent[solvent.name]="..tostring(searchSolvent[solvent.name]))
							if searchSolvent["count"] ~= 0 and searchSolvent[solvent.name] ~= nil and searchSolvent[solvent.name] then
								currentSolvent = {}
								currentSolvent = solvent
								currentAmount = amount
							else
								currentSolvent = nil
								currentAmount = amount1
							end
							if searchSolvent["count"] == 0 or (searchSolvent["count"] ~= 0 and currentSolvent ~= nil) then
								local potion = PotMakerXL.Potion:new{traits = checkMatches, ingredients = {[1] = ingredient1, [2] = ingredient2}, solvent = currentSolvent, quantity = math.min(amount1, amount2, currentAmount)}
								if potion ~= nil and potion.name ~= nil and potion:conformsToSearch(searchTerms) then
									table.insert(PotMakerXL.doablePotions, potion)
								end
								-- if three slots for alchemy then
								if (IsThirdAlchemySlotUnlocked() or PotionMakerSavedVariables.fakeThirdSlot) and not PotMakerXL.potion2ReagentFilter then
									for ingredient3, amount3 in pairs(PotMakerXL.Inventory.reagents) do
										if ingredient3 ~= nil and ingredient1 ~= ingredient3 and ingredient2 ~= ingredient3 and (not PotMakerXL.onlyReagentFilter or searchReagent["count"] == 0 or (searchReagent[ingredient3.name] ~= nil and searchReagent[ingredient3.name])) then
											local combinationMatches = combinationIngredient:matchIngredient(ingredient3)
											if #combinationMatches > 0 then
												local ingredient3ChangedPotion = false
												if #combinationMatches ~= #checkMatches then
													ingredient3ChangedPotion = true
												else
													local allCheckMatchesInCombinationMatches = true
													for _, trait1 in pairs(combinationMatches) do
														local trait1InCheckMatches = false
														for _, trait2 in pairs(checkMatches) do
															if trait1 == trait2 then
																trait1InCheckMatches = true
															end
														end
														if not trait1InCheckMatches then
															allCheckMatchesInCombinationMatches = false
															break
														end
													end
													if not allCheckMatchesInCombinationMatches then
														ingredient3ChangedPotion = true
													end
												end
												if ingredient3ChangedPotion then
													--create potion
													local potion = PotMakerXL.Potion:new{traits = combinationMatches, ingredients = {[1] = ingredient1, [2] = ingredient2, [3] = ingredient3}, solvent = currentSolvent, quantity = math.min(amount1, amount2, amount3, currentAmount)}
													if potion ~= nil and potion.name ~= nil and potion:conformsToSearch(searchTerms) then
														table.insert(PotMakerXL.doablePotions, potion)
													end
												end
											end
										end
									end
								end
							end
							-- no solvent selected then one loop
							if searchSolvent["count"] == 0 then break end
						end
                    end
                end
            end
        end
    end
     -- for k,v in pairs(PotMakerXL.doablePotions) do
         -- d("----------------------------")
         -- for k2,v2 in pairs(v.ingredients) do
             -- d(v2.name)
         -- end
     -- end
end

function PotMakerXL.interactWithAlchemyStation(eventCode, craftSkill, sameStation)
    if craftSkill == CRAFTING_TYPE_ALCHEMY then
		-- check xp gain
		if PotionMakerSavedVariables.XPMode then EVENT_MANAGER:RegisterForEvent("PotionMakerExtended", EVENT_SKILL_XP_UPDATE, function(eventCode, skillType, skillIndex, reason, rank, previousXP, currentXP) if reason == PROGRESS_REASON_TRADESKILL or reason == PROGRESS_REASON_TRADESKILL_TRAIT then PotMakerXL:OnSkillXP(skillType, skillIndex, previousXP, currentXP) end end) end

		PotMakerXL.atAlchemyStation = true
		if IsInGamepadPreferredMode() then return end
		PotMakerXL.doAlchemy()
    end
end

function PotMakerXL.doAlchemy()
    PotionMakerXL:SetHidden(false)
    -- check if player has Laboratory Use skill
    -- local name, _, _, _, _, purchased, _ = GetSkillAbilityInfo(SKILL_TYPE_TRADESKILL, 1, 5)
    -- if purchased then
        -- PotMakerXL.playerHasLaboratoryUse = true
    -- end
	WINDOW_MANAGER:GetControlByName("ZO_AlchemyTopLevelTooltip"):ClearAnchors()
	WINDOW_MANAGER:GetControlByName("ZO_AlchemyTopLevelTooltip"):SetAnchor(BOTTOMRIGHT, ZO_AlchemyTopLevelSlotContainer, BOTTOMLEFT, 20, 30) --replace tooltip
    PotMakerXL.addStuffToInventory()
    PotMakerXL.updateControls()
end

function PotMakerXL.endAlchemy()
    if not PotionMakerXL:IsHidden() or not PotionMakerXLOutput:IsHidden() or PotMakerXL.atAlchemyStation then
        PotMakerXL.doablePotions = {}
        PotMakerXL.Inventory.reagents = {}
        PotMakerXL.Inventory.solvents = {}
        PotMakerXL.SolventFilterControls = {}
        for k, v in pairs(PotMakerXL.ResultControls) do
            v:SetHidden(true)
        end
        PotMakerXL.ResultControls = {}
        PotionMakerXL:SetHidden(true)
        PotionMakerXLOutput:SetHidden(true)
		PotionMakerXLMsgWindow:SetHidden(true)
        PotMakerXL.atAlchemyStation = false
		WINDOW_MANAGER:GetControlByName("ZO_AlchemyTopLevelTooltip"):ClearAnchors()
		WINDOW_MANAGER:GetControlByName("ZO_AlchemyTopLevelTooltip"):SetAnchor(BOTTOM, ZO_AlchemyTopLevel, BOTTOM, 0, -335) --original tooltip position
		if PotionMakerSavedVariables.XPMode then EVENT_MANAGER:UnregisterForEvent("PotionMakerExtended", EVENT_SKILL_XP_UPDATE) end
    end
end

function PotMakerXL.craftCompleted(craftSkill)
    if(PotMakerXL.atAlchemyStation) then
        for k, v in pairs(PotMakerXL.Inventory.solvents) do
            local name, stack, _, _, _, _, _, _= GetItemInfo(k.bag, k.slot)
            if name == nil or stack < 1 then
 --               d(PME_Lang[language].no .. k.name .. PME_Lang[language].left)
                for _, control in pairs(PotMakerXL.SolventFilterControls) do
                    if k.name == control.text then
--                        if PotMakerXL.usedSolvent ~= nil and PotMakerXL.usedSolvent.name == control.text then
--                            PotMakerXL.usedSolvent = nil
--                        end
                        ZO_CheckButton_SetUnchecked(control)
                        control:SetHidden(true)
                    end
                end
            end
        end
        PotMakerXL.Inventory.reagents = {}
        PotMakerXL.Inventory.solvents = {}
        PotMakerXL.addStuffToInventory()
        PotMakerXL.updateControls()
		
		-- refresh traits icon on result page
		PotMakerXL.refreshTraits()
    end
end

function PotMakerXL:OnSkillXP(skillType, skillIndex, previousXP, currentXP)
	-- // when gain xp via crafting
	local name,rank = GetSkillLineInfo(skillType, skillIndex)
	local gainXP = currentXP - previousXP

	PotMakerXL:addMsg(PME_Lang[language].skill .. " |c"..COLOR_KHRILLSELECT .. zo_strformat(SI_TOOLTIP_ITEM_NAME, name) .. "|r = |c"..COLOR_KHRILLSELECT.."+" .. gainXP .. "xp|r")
--	CHAT_SYSTEM:AddMessage(PME_Lang[language].skill .. " |c"..COLOR_KHRILLSELECT .. zo_strformat(SI_TOOLTIP_ITEM_NAME, name) .. "|r = |c"..COLOR_KHRILLSELECT.."+" .. gainXP .. "xp|r")
end

function PotMakerXL.checkAll(checkButton, isChecked)
    local labelControl = WINDOW_MANAGER:GetControlByName("PotionMakerXLAllMustNotCheckBoxText")
    if isChecked then
        labelControl:SetText(PME_Lang[language].uncheck_all)
    else
        labelControl:SetText(PME_Lang[language].check_all)
    end
    for _, checkBox in pairs(PotMakerXL.MustNotFilterControls) do
        if isChecked then
            ZO_CheckButton_SetChecked(checkBox)
            PotMakerXL.checkButtonClicked(checkBox, true)
        else
            ZO_CheckButton_SetUnchecked(checkBox)
            PotMakerXL.checkButtonClicked(checkBox, false)
        end
    end
end

function PotMakerXL.checkButtonClicked(checkButton, isChecked)
    if isChecked then
        local oppositeTrait = PME_Lang[language].oppositeTraits[checkButton.text]
        local control = nil
        for _, checkBox in pairs(PotMakerXL.MustFilterControls) do
            if checkBox.text == oppositeTrait then
                control = checkBox
                break
            end
        end
        if control == nil then
            for _, checkBox in pairs(PotMakerXL.MustNotFilterControls) do
                if checkBox.text == oppositeTrait then
                    control = checkBox
                    break
                end
            end
        end
        if control ~= nil and ZO_CheckButton_IsChecked(control) then ZO_CheckButton_SetUnchecked(control) end
		if control ~= nil and control:GetNamedChild("Text") then control:GetNamedChild("Text"):SetColor(GetInterfaceColor(INTERFACE_COLOR_TYPE_TEXT_COLORS,INTERFACE_TEXT_COLOR_NORMAL)) end
		if checkButton:GetNamedChild("Text") then checkButton:GetNamedChild("Text"):SetColor(HexToRGBA("FF6A00FF")) end
	else
		if control ~= nil and control:GetNamedChild("Text") then control:GetNamedChild("Text"):SetColor(HexToRGBA("FF6A00FF")) end
		if checkButton:GetNamedChild("Text")then checkButton:GetNamedChild("Text"):SetColor(GetInterfaceColor(INTERFACE_COLOR_TYPE_TEXT_COLORS,INTERFACE_TEXT_COLOR_NORMAL)) end
	end
end

function PotMakerXL.solventCheckButtonClicked(checkButton, isChecked)
    for _, control in pairs(PotMakerXL.SolventFilterControls) do
        if control.text ~= checkButton.text then
            ZO_CheckButton_SetUnchecked(control)
			if control:GetNamedChild("Text") then control:GetNamedChild("Text"):SetColor(GetInterfaceColor(INTERFACE_COLOR_TYPE_TEXT_COLORS,INTERFACE_TEXT_COLOR_NORMAL)) end
        end
    end
    if isChecked then
--        for solvent, _ in pairs(PotMakerXL.Inventory.solvents) do
--            if solvent.name == checkButton.text then
--                PotMakerXL.usedSolvent = solvent
--                break
--            end
--        end
		if checkButton:GetNamedChild("Text") then checkButton:GetNamedChild("Text"):SetColor(HexToRGBA("FF6A00FF")) end
    else
		if checkButton:GetNamedChild("Text")then checkButton:GetNamedChild("Text"):SetColor(GetInterfaceColor(INTERFACE_COLOR_TYPE_TEXT_COLORS,INTERFACE_TEXT_COLOR_NORMAL)) end
--        PotMakerXL.usedSolvent = nil
    end
end

function PotMakerXL.showTraitTip(resultButton, state)
	local control=WINDOW_MANAGER:GetControlByName(resultButton:GetName().."Tip")
	if state then
		control:SetColor(resultButton:GetColor())
		control:SetText(resultButton.Trait)
	else
		control:SetText("")
	end
	control:SetHidden(not state)
end

function PotMakerXL.searchAgain()
    -- local showSolvents = true
    -- local showReagents = true
    
    -- local tab = ZO_AlchemyTopLevelInventoryTabsActive:GetText()
    -- if tab == "Solvent" then
        -- showReagents = false
    -- elseif tab == "Reagents" then
        -- showSolvents = false
    -- end

    -- for index = 1, getmetatable(ZO_AlchemyTopLevelInventoryBackpackContents).__index.GetNumChildren(ZO_AlchemyTopLevelInventoryBackpackContents) do
        -- local child = getmetatable(ZO_AlchemyTopLevelInventoryBackpackContents).__index.GetChild(ZO_AlchemyTopLevelInventoryBackpackContents, index)
        -- if getmetatable(child).__index["dataEntry"] ~= nil then
            -- if string.find(getmetatable(child).__index.GetName(child), "ZO_AlchemyTopLevelInventoryBackpack1") ~= nil then
                -- getmetatable(child).__index.SetHidden(child, false)
            -- elseif string.find(getmetatable(child).__index.GetName(child), "ZO_AlchemyTopLevelInventoryBackpack2") ~= nil then
                -- getmetatable(child).__index.SetHidden(child, false)
            -- end
        -- end
    -- end
    PotMakerXL.resultsMaxIndex = 0
    local atAlchemyStation = false
    if PotMakerXL.atAlchemyStation then
        atAlchemyStation = true
    end
    PotMakerXL.endAlchemy()
    PotMakerXL.atAlchemyStation = atAlchemyStation
    if atAlchemyStation then
        PotMakerXL.interactWithAlchemyStation(nil, 4, true)
    else
        PotMakerXL.doAlchemy()
    end
    PotionMakerXL:SetHidden(false)
    PotionMakerXL:SetMovable(true)
    PotionMakerXLOutput:SetHidden(true)
    PotMakerXL.updateControls()
end

function PotMakerXL.previous()
    PotMakerXL.resultsMaxIndex = PotMakerXL.resultsMaxIndex - 10
    for k, v in pairs(PotMakerXL.ResultControls) do
        v:SetHidden(true)
    end
    -- if PotMakerXL.resultsMaxIndex < 0 then
        -- PotMakerXL.resultsMaxIndex = 0
    -- end
    PotMakerXL.search()
end

function PotMakerXL.next()
    PotMakerXL.resultsMaxIndex = PotMakerXL.resultsMaxIndex + 10
    for k, v in pairs(PotMakerXL.ResultControls) do
        v:SetHidden(true)
    end
    PotMakerXL.search()
end

function PotMakerXL.search()
    if PotMakerXL.resultsMaxIndex == 0 then
        local filters = {}
		local filterSolvents = {}
		local filterReagent = {}
        for _, checkBox in pairs(PotMakerXL.MustFilterControls) do
            if ZO_CheckButton_IsChecked(checkBox) then
                filters[checkBox.text] = true
            end
        end
        for _, checkBox in pairs(PotMakerXL.MustNotFilterControls) do
            if ZO_CheckButton_IsChecked(checkBox) then
                filters[checkBox.text] = false
            end
        end
		filterSolvents["count"] = 0
        for _, checkBox in pairs(PotMakerXL.SolventFilterControls) do
            if not checkBox:GetNamedChild("Outline"):IsControlHidden() then
--            if ZO_CheckButton_IsChecked(checkBox) then
                filterSolvents[checkBox.text] = true
				filterSolvents["count"] = filterSolvents["count"] +1
            end
        end
		filterReagent["count"] = 0
        for _, checkBox in pairs(PotMakerXL.ReagentFilterControls) do
            if not checkBox:GetNamedChild("Outline"):IsControlHidden() then
                filterReagent[checkBox.reagent.name] = true
				filterReagent["count"] = filterReagent["count"] +1
            end
        end
		PotMakerXL.onlyReagentFilter = ZO_CheckButton_IsChecked(WINDOW_MANAGER:GetControlByName("PotionMakerXLOnlyReagent"))
		PotMakerXL.potion2ReagentFilter = ZO_CheckButton_IsChecked(WINDOW_MANAGER:GetControlByName("PotionMakerXLOnly2"))
		PotMakerXL.nameContainsFilter = WINDOW_MANAGER:GetControlByName("PotionMakerXLNameContainsEditBox"):GetText()
		PotMakerXL.doablePotions = {}
        PotMakerXL.findDoablePotions(filters, filterSolvents, filterReagent)
    end
    -- local i = 1
    if #PotMakerXL.doablePotions > PotMakerXL.resultsMaxIndex + 10 then
        WINDOW_MANAGER:GetControlByName("PotionMakerXLOutputNextButton"):SetHidden(false)
    else
        WINDOW_MANAGER:GetControlByName("PotionMakerXLOutputNextButton"):SetHidden(true)
    end
    if PotMakerXL.resultsMaxIndex > 0 then
        WINDOW_MANAGER:GetControlByName("PotionMakerXLOutputPreviousButton"):SetHidden(false)
    else
        WINDOW_MANAGER:GetControlByName("PotionMakerXLOutputPreviousButton"):SetHidden(true)
 
    end
	if PotMakerXL.resultsMaxIndex == 0 and #PotMakerXL.doablePotions < 11 then
        WINDOW_MANAGER:GetControlByName("PotionMakerXLOutputPageLabel"):SetHidden(true)
	else
        WINDOW_MANAGER:GetControlByName("PotionMakerXLOutputPageLabel"):SetText("|c"..COLOR_KHRILLSELECT..tostring(math.floor((PotMakerXL.resultsMaxIndex)/10)+1) .."|r / ".. tostring(math.floor((#PotMakerXL.doablePotions-1)/10)+1))
        WINDOW_MANAGER:GetControlByName("PotionMakerXLOutputPageLabel"):SetHidden(false)
	end

	local resultLineOffsetX = 0
    local resultLineOffsetY = 0
    for i, v in pairs(PotMakerXL.doablePotions) do
        if i > PotMakerXL.resultsMaxIndex then
            local index = i - PotMakerXL.resultsMaxIndex
            local uniqueName = "PotionMakerXLResult"
            local ingredients = v.ingredients
            table.sort(ingredients, function (a, b) return string.lower(a.name) < string.lower(b.name) end)
            for _, ingredient in pairs(ingredients) do
                uniqueName = uniqueName .. ingredient.name
            end
			if v.solvent ~= nil and v.solvent.name ~= nil then
                uniqueName = "PotionMakerXLResult" .. v.solvent.name .. uniqueName
            else
                uniqueName = "PotionMakerXLResult" .. uniqueName
            end
            local control = WINDOW_MANAGER:GetControlByName(uniqueName)

            if control == nil then
                control = CreateControlFromVirtual(uniqueName, PotionMakerXLOutputResultsBG, "PotionMakerXLResult")
            else
                control:SetHidden(false)
            end
            WINDOW_MANAGER:GetControlByName(uniqueName .. "ShowButton"):SetText(PME_Lang[language].show)
			
			-- display icon traits
			local count = 1
			local traitColor, traitTexture
			for _, t in pairs(v.traits) do
				if t ~= nil then
					traitColor = nil
					traitName = t:sub(1, -2)
					if string.sub(t, -1) == "-" then
						traitColor = "FF7F50FF"
					elseif string.sub(t, -1) == "/" then
						traitColor = "FF0000FF"
					elseif string.sub(t, -1) == "+" then
						traitColor = "CBFF8CFF" --"9ACD32FF"
					elseif string.sub(t, -1) == "*" then
						traitColor = "00FF00FF" --"248700FF" --"228B22FF"
					end
					if traitColor ~= nil then
						-- check unknown traits (icon==nil)
						traitTexture = nil
			            for _, ingredient in pairs(v.ingredients) do
--						d(ingredient.name.." -> "..traitName.."="..tostring(ingredient.iconTraits[traitName]))
--						d(PotMakerXL.allReagents[ingredient.name][traitName])
							if PotMakerXL.allReagents[ingredient.name] ~= nil and PotMakerXL.allReagents[ingredient.name][traitName] ~= nil then
								if ingredient.iconTraits[traitName] == nil and not PotMakerXL.allReagents[ingredient.name][traitName] then
									traitTexture = TEXTURE_TRAITUNKNOWN
								else
									if traitTexture == nil then traitTexture = ingredient.iconTraits[traitName] end
								end
							end
						end
						if traitTexture == nil then traitTexture = TEXTURE_TRAITUNKNOWN end
--						d("|c" .. traitColor .. traitName.. "|r :"..tostring(traitTexture))
						WINDOW_MANAGER:GetControlByName(uniqueName):GetNamedChild("Trait"..count).Trait = traitName
						WINDOW_MANAGER:GetControlByName(uniqueName):GetNamedChild("Trait"..count):SetColor(HexToRGBA(traitColor))
						WINDOW_MANAGER:GetControlByName(uniqueName):GetNamedChild("Trait"..count):SetTexture(traitTexture)
						WINDOW_MANAGER:GetControlByName(uniqueName):GetNamedChild("Trait"..count):SetHidden(false)
						count = count +1
					end
				end
			end
			
			-- display ingredients
			control:SetSimpleAnchorParent(resultLineOffsetX, resultLineOffsetY + ((control:GetHeight()+2)*(index-1)))

			local ingredientsString = PotMakerXL.Potion.getIngredientString(v)
            for j = 1, #v.ingredients do
				WINDOW_MANAGER:GetControlByName(uniqueName):GetNamedChild("Reagent"..j):SetTexture(v.ingredients[j].icon)
				WINDOW_MANAGER:GetControlByName(uniqueName):GetNamedChild("Reagent"..j):SetHidden(false)
            end
			-- solvent
			if v.solvent ~= nil then
				WINDOW_MANAGER:GetControlByName(uniqueName):GetNamedChild("Reagent4"):SetTexture(v.solvent.icon)
				WINDOW_MANAGER:GetControlByName(uniqueName):GetNamedChild("Reagent4"):SetHidden(false)
			end
            control:SetText("                         "..ingredientsString)
            PotMakerXL.ResultControls[index] = control

			-- display potion
			WINDOW_MANAGER:GetControlByName(uniqueName):GetNamedChild("Potion"):SetText(PotMakerXL.Potion:getPotionNameString(v))			
			WINDOW_MANAGER:GetControlByName(uniqueName):GetNamedChild("Potion"):SetHidden(false)			
		end
        if i >= PotMakerXL.resultsMaxIndex + 10 then
            break
        end
    end
--    d("________________________________")
--    d(#PotMakerXL.doablePotions .. " possible combinations found.")
    PotionMakerXLOutput:SetHidden(false)
    PotionMakerXLOutput:SetMovable(true)
    PotionMakerXL:SetHidden(true)
end

function PotMakerXL.refreshTraits()
    for i, v in pairs(PotMakerXL.doablePotions) do
        if i > PotMakerXL.resultsMaxIndex then
            local index = i - PotMakerXL.resultsMaxIndex
            local uniqueName = "PotionMakerXLResult"
            local ingredients = v.ingredients
            table.sort(ingredients, function (a, b) return string.lower(a.name) < string.lower(b.name) end)
            for _, ingredient in pairs(ingredients) do
                uniqueName = uniqueName .. ingredient.name
            end
			if v.solvent ~= nil and v.solvent.name ~= nil then
--			if(usedSolvent ~= nil) then
                uniqueName = "PotionMakerXLResult" .. v.solvent.name .. uniqueName --PotMakerXL.usedSolvent.name .. uniqueName
            else
                uniqueName = "PotionMakerXLResult" .. uniqueName
            end
            local control = WINDOW_MANAGER:GetControlByName(uniqueName)

            if control == nil then
                control = CreateControlFromVirtual(uniqueName, PotionMakerXLOutputResultsBG, "PotionMakerXLResult")
            else
                control:SetHidden(false)
            end
 			
			-- display icon traits

			local count = 1
			local traitColor, traitTexture
			for _, t in pairs(v.traits) do
				if t ~= nil then
					traitColor = nil
					traitName = t:sub(1, -2)
					if string.sub(t, -1) == "-" then
						traitColor = "FF7F50FF"
					elseif string.sub(t, -1) == "/" then
						traitColor = "FF0000FF"
					elseif string.sub(t, -1) == "+" then
						traitColor = "CBFF8CFF" --"9ACD32FF"
					elseif string.sub(t, -1) == "*" then
						traitColor = "00FF00FF" --"248700FF" --"228B22FF"
					end
					if traitColor ~= nil then
						traitTexture = nil
			            for _, ingredient in pairs(v.ingredients) do
							--update traits (if discover new one)
							for k1, v1 in pairs(PotMakerXL.Inventory.reagents) do
								if k1.name == ingredient.name then
									ingredient.traits = k1.traits
									ingredient.iconTraits = k1.iconTraits
									break
								end
							end

							-- check unknown traits (icon==nil)
--							d(ingredient.name.." -> "..traitName.."="..tostring(ingredient.iconTraits[traitName]))
--							d(PotMakerXL.allReagents[ingredient.name][traitName])
							if PotMakerXL.allReagents[ingredient.name] ~= nil and PotMakerXL.allReagents[ingredient.name][traitName] ~= nil then
								if ingredient.iconTraits[traitName] == nil and not PotMakerXL.allReagents[ingredient.name][traitName] then
									traitTexture = TEXTURE_TRAITUNKNOWN
								else
									if traitTexture == nil then traitTexture = ingredient.iconTraits[traitName] end
								end
							end
						end
						if traitTexture == nil then traitTexture = TEXTURE_TRAITUNKNOWN end
--						d("|c" .. traitColor .. traitName.. "|r :"..tostring(traitTexture))
						WINDOW_MANAGER:GetControlByName(uniqueName):GetNamedChild("Trait"..count).Trait = traitName
						WINDOW_MANAGER:GetControlByName(uniqueName):GetNamedChild("Trait"..count):SetColor(HexToRGBA(traitColor))
						WINDOW_MANAGER:GetControlByName(uniqueName):GetNamedChild("Trait"..count):SetTexture(traitTexture)
						WINDOW_MANAGER:GetControlByName(uniqueName):GetNamedChild("Trait"..count):SetHidden(false)
						count = count +1
					end
				end
			end
        end
        if i >= PotMakerXL.resultsMaxIndex + 10 then
            break
        end
    end
end

function PotMakerXL.stripTrailingJunk(words)
    local junkIndex = string.find(words, "^", 1, true)
    if junkIndex ~= nil and junkIndex > 0 then
        return string.sub(words, 1, junkIndex-1)
    end
    return words
end

function PotMakerXL.PotionMakerOutputSetFrameCoords(self)
    local x, y = 0, 0
    local addOnX, addOnY = PotionMakerXLOutput:GetCenter()
    local guiRootX, guiRootY = GuiRoot:GetCenter()
    x = addOnX - guiRootX
    y = addOnY - guiRootY
    
    PotionMakerSavedVariables.resultsWindowX = x
    PotionMakerSavedVariables.resultsWindowY = y

    if PotionMakerSavedVariables.sameWindowCoords then
        PotionMakerSavedVariables.mainWindowX = x
        PotionMakerSavedVariables.mainWindowY = y
        PotionMakerXL:ClearAnchors()
        PotionMakerXL:SetAnchor(CENTER, GuiRoot, CENTER, PotionMakerSavedVariables.mainWindowX, PotionMakerSavedVariables.mainWindowY)
    end
end

function PotMakerXL.PotionMakerSetFrameCoords(self)
    local x, y = 0, 0
    local addOnX, addOnY = PotionMakerXL:GetCenter()
    local guiRootX, guiRootY = GuiRoot:GetCenter()
    x = addOnX - guiRootX
    y = addOnY - guiRootY
    
    PotionMakerSavedVariables.mainWindowX = x
    PotionMakerSavedVariables.mainWindowY = y

    if PotionMakerSavedVariables.sameWindowCoords then
        PotionMakerSavedVariables.resultsWindowX = x
        PotionMakerSavedVariables.resultsWindowY = y
        PotionMakerXLOutput:ClearAnchors()
        PotionMakerXLOutput:SetAnchor(CENTER, GuiRoot, CENTER, PotionMakerSavedVariables.mainWindowX, PotionMakerSavedVariables.mainWindowY)
    end
end

function PotMakerXL:initWindows()
	PotMakerXL:toggleEnableBtn(PotionMakerSavedVariables.enableButton) -- init button ESO UI
	
	WINDOW_MANAGER:GetControlByName("PotionMakerXLCloseButtonTexture"):SetTexture(TEXTURE_CLOSE)
    WINDOW_MANAGER:GetControlByName("PotionMakerXLOutputCloseButtonTexture"):SetTexture(TEXTURE_CLOSE)
    WINDOW_MANAGER:GetControlByName("PotionMakerXLBagButtonTexture"):SetTexture(TEXTURE_BAG)
    WINDOW_MANAGER:GetControlByName("PotionMakerXLBankButtonTexture"):SetTexture(TEXTURE_BANK)

    WINDOW_MANAGER:GetControlByName("PotionMakerXLOutputResultsLabel"):SetText(PME_Lang[language].search_results)
    WINDOW_MANAGER:GetControlByName("PotionMakerXLOutputCombinationLabel"):SetText(PME_Lang[language].combinations)
    WINDOW_MANAGER:GetControlByName("PotionMakerXLOutputPotionLabel"):SetText(PME_Lang[language].potions)
    WINDOW_MANAGER:GetControlByName("PotionMakerXLOutputTraitLabel"):SetText(PME_Lang[language].traits)
    WINDOW_MANAGER:GetControlByName("PotionMakerXLOutputNextButton"):SetText(PME_Lang[language].nexxt)
    WINDOW_MANAGER:GetControlByName("PotionMakerXLOutputPreviousButton"):SetText(PME_Lang[language].previous)
    if PotionMakerSavedVariables.sameWindowCoords then
        if PotionMakerXL:GetHandler("OnMoveStop") == nil then PotionMakerXL:SetHandler("OnMoveStop", PotMakerXL.PotionMakerSetFrameCoords) end
        PotionMakerXL:SetAnchor(CENTER, GuiRoot, CENTER, PotionMakerSavedVariables.mainWindowX, PotionMakerSavedVariables.mainWindowY)
        PotionMakerXL:SetMovable(true)

        if PotionMakerXLOutput:GetHandler("OnMoveStop") == nil then PotionMakerXLOutput:SetHandler("OnMoveStop", PotMakerXL.PotionMakerOutputSetFrameCoords) end
        PotionMakerXLOutput:SetAnchor(CENTER, GuiRoot, CENTER, PotionMakerSavedVariables.mainWindowX, PotionMakerSavedVariables.mainWindowY)
        PotionMakerXLOutput:SetMovable(true)
    else
        if PotionMakerXL:GetHandler("OnMoveStop") == nil then PotionMakerXL:SetHandler("OnMoveStop", PotMakerXL.PotionMakerSetFrameCoords) end
        PotionMakerXL:SetAnchor(CENTER, GuiRoot, CENTER, PotionMakerSavedVariables.mainWindowX, PotionMakerSavedVariables.mainWindowY)
        PotionMakerXL:SetMovable(true)

        if PotionMakerXLOutput:GetHandler("OnMoveStop") == nil then PotionMakerXLOutput:SetHandler("OnMoveStop", PotMakerXL.PotionMakerOutputSetFrameCoords) end
        PotionMakerXLOutput:SetAnchor(CENTER, GuiRoot, CENTER, PotionMakerSavedVariables.resultsWindowX, PotionMakerSavedVariables.resultsWindowY)
        PotionMakerXLOutput:SetMovable(true)
    end
    
    WINDOW_MANAGER:GetControlByName("PotionMakerXLSearchButton"):SetText(PME_Lang[language].search)
    WINDOW_MANAGER:GetControlByName("PotionMakerXLOutputSearchButton"):SetText(PME_Lang[language].search_again)
    WINDOW_MANAGER:GetControlByName("PotionMakerXLMustLabel"):SetText(PME_Lang[language].must_have)
    WINDOW_MANAGER:GetControlByName("PotionMakerXLMustNotLabel"):SetText(PME_Lang[language].must_not_have)
    WINDOW_MANAGER:GetControlByName("PotionMakerXLSolventLabel"):SetText(PME_Lang[language].use_solvent)
    WINDOW_MANAGER:GetControlByName("PotionMakerXLReagentLabel"):SetText(PME_Lang[language].use_reagent)
    WINDOW_MANAGER:GetControlByName("PotionMakerXLOnlyReagentText"):SetText(PME_Lang[language].only)
	ZO_CheckButton_SetToggleFunction(WINDOW_MANAGER:GetControlByName("PotionMakerXLOnlyReagent"), PotMakerXL.checkButtonClicked)
    WINDOW_MANAGER:GetControlByName("PotionMakerXLOnly2Text"):SetText(PME_Lang[language].potion2reagents)
	ZO_CheckButton_SetToggleFunction(WINDOW_MANAGER:GetControlByName("PotionMakerXLOnly2"), PotMakerXL.checkButtonClicked)
	WINDOW_MANAGER:GetControlByName("PotionMakerXLOnly2"):SetHidden(not (IsThirdAlchemySlotUnlocked() or PotionMakerSavedVariables.fakeThirdSlot))
	WINDOW_MANAGER:GetControlByName("PotionMakerXLOnly2BG"):SetHidden(not (IsThirdAlchemySlotUnlocked() or PotionMakerSavedVariables.fakeThirdSlot))
	WINDOW_MANAGER:GetControlByName("PotionMakerXLOnly2Text"):SetHidden(not (IsThirdAlchemySlotUnlocked() or PotionMakerSavedVariables.fakeThirdSlot))
    WINDOW_MANAGER:GetControlByName("PotionMakerXLNameContainsText"):SetText(PME_Lang[language].name_contains)
	PotMakerXL.updateControls()
end

function PotMakerXL.updateControl(traitName, posX, count)
        local checkBoxName = PME_Lang[language].checkBoxNames[traitName]
        local control = CreateControlFromVirtual(checkBoxName, PotionMakerXLSearchBG, "PotionMakerXLCheckBox")
        control:SetSimpleAnchorParent(posX, (control:GetHeight()+2)*(count-1) +5)
        control.text = PME_Lang[language].traitNames[traitName]
        ZO_CheckButton_SetToggleFunction(control, PotMakerXL.checkButtonClicked)
        local labelControl = CreateControlFromVirtual(checkBoxName .. "Text", control, "PotionMakerXLCheckBoxText")
        labelControl:SetText(PME_Lang[language].traitNames[traitName])
        return control
end
function PotMakerXL.updateControls()
	local xPosMustFilter = 10
	local xPosMustNotFilter = 370
	local xPosSolventFilter = 8 --710
	
    if #PotMakerXL.MustFilterControls == 0 then
		local cnt = 1
		PotMakerXL.MustFilterControls[cnt] = PotMakerXL.updateControl("Restore Health", xPosMustFilter, cnt)
		cnt = cnt +1
		PotMakerXL.MustFilterControls[cnt] = PotMakerXL.updateControl("Restore Magicka", xPosMustFilter, cnt)
		cnt = cnt +1
		PotMakerXL.MustFilterControls[cnt] = PotMakerXL.updateControl("Restore Stamina", xPosMustFilter, cnt)
		cnt = cnt +1
		PotMakerXL.MustFilterControls[cnt] = PotMakerXL.updateControl("Increase Armor", xPosMustFilter, cnt)
		cnt = cnt +1
		PotMakerXL.MustFilterControls[cnt] = PotMakerXL.updateControl("Unstoppable", xPosMustFilter, cnt)
		cnt = cnt +1
		PotMakerXL.MustFilterControls[cnt] = PotMakerXL.updateControl("Speed", xPosMustFilter, cnt)
		cnt = cnt +1
		if language == "fr" then
			PotMakerXL.MustFilterControls[cnt] = PotMakerXL.updateControl("Weapon Crit", xPosMustFilter, cnt)
			cnt = cnt +1
			PotMakerXL.MustFilterControls[cnt] = PotMakerXL.updateControl("Spell Crit", xPosMustFilter, cnt)
			cnt = cnt +1
			PotMakerXL.MustFilterControls[cnt] = PotMakerXL.updateControl("Increase Weapon Power", xPosMustFilter, cnt)
			cnt = cnt +1
			PotMakerXL.MustFilterControls[cnt] = PotMakerXL.updateControl("Increase Spell Power", xPosMustFilter, cnt)
		else
			PotMakerXL.MustFilterControls[cnt] = PotMakerXL.updateControl("Increase Weapon Power", xPosMustFilter, cnt)
			cnt = cnt +1
			PotMakerXL.MustFilterControls[cnt] = PotMakerXL.updateControl("Increase Spell Power", xPosMustFilter, cnt)
			cnt = cnt +1
			PotMakerXL.MustFilterControls[cnt] = PotMakerXL.updateControl("Weapon Crit", xPosMustFilter, cnt)
			cnt = cnt +1
			PotMakerXL.MustFilterControls[cnt] = PotMakerXL.updateControl("Spell Crit", xPosMustFilter, cnt)
		end
		cnt = cnt +1
		PotMakerXL.MustFilterControls[cnt] = PotMakerXL.updateControl("Increase Spell Resist", xPosMustFilter, cnt)
		cnt = cnt +1
		PotMakerXL.MustFilterControls[cnt] = PotMakerXL.updateControl("Invisible", xPosMustFilter, cnt)
		cnt = cnt +1
		PotMakerXL.MustFilterControls[cnt] = PotMakerXL.updateControl("Detection", xPosMustFilter, cnt)
    end

    if #PotMakerXL.MustNotFilterControls == 0 then
		local cnt = 1
		PotMakerXL.MustNotFilterControls[cnt] = PotMakerXL.updateControl("Ravage Health", xPosMustNotFilter, cnt)
		cnt = cnt +1
		PotMakerXL.MustNotFilterControls[cnt] = PotMakerXL.updateControl("Ravage Magicka", xPosMustNotFilter, cnt)
		cnt = cnt +1
		PotMakerXL.MustNotFilterControls[cnt] = PotMakerXL.updateControl("Ravage Stamina", xPosMustNotFilter, cnt)
		cnt = cnt +1
		PotMakerXL.MustNotFilterControls[cnt] = PotMakerXL.updateControl("Lower Armor", xPosMustNotFilter, cnt)
		cnt = cnt +1
		PotMakerXL.MustNotFilterControls[cnt] = PotMakerXL.updateControl("Stun", xPosMustNotFilter, cnt)
		cnt = cnt +1
		PotMakerXL.MustNotFilterControls[cnt] = PotMakerXL.updateControl("Reduce Speed", xPosMustNotFilter, cnt)
		cnt = cnt +1
		if language == "fr" then
			PotMakerXL.MustNotFilterControls[cnt] = PotMakerXL.updateControl("Lower Weapon Crit", xPosMustNotFilter, cnt)
			cnt = cnt +1
			PotMakerXL.MustNotFilterControls[cnt] = PotMakerXL.updateControl("Lower Spell Crit", xPosMustNotFilter, cnt)
			cnt = cnt +1
			PotMakerXL.MustNotFilterControls[cnt] = PotMakerXL.updateControl("Lower Weapon Power", xPosMustNotFilter, cnt)
			cnt = cnt +1
			PotMakerXL.MustNotFilterControls[cnt] = PotMakerXL.updateControl("Lower Spell Power", xPosMustNotFilter, cnt)
		else
			PotMakerXL.MustNotFilterControls[cnt] = PotMakerXL.updateControl("Lower Weapon Power", xPosMustNotFilter, cnt)
			cnt = cnt +1
			PotMakerXL.MustNotFilterControls[cnt] = PotMakerXL.updateControl("Lower Spell Power", xPosMustNotFilter, cnt)
			cnt = cnt +1
			PotMakerXL.MustNotFilterControls[cnt] = PotMakerXL.updateControl("Lower Weapon Crit", xPosMustNotFilter, cnt)
			cnt = cnt +1
			PotMakerXL.MustNotFilterControls[cnt] = PotMakerXL.updateControl("Lower Spell Crit", xPosMustNotFilter, cnt)
		end
		cnt = cnt +1
		PotMakerXL.MustNotFilterControls[cnt] = PotMakerXL.updateControl("Lower Spell Resist", xPosMustNotFilter, cnt)
		cnt = cnt +1
       
        local control = CreateControlFromVirtual("PotionMakerXLAllMustNotCheckBox", PotionMakerXLSearchBG, "PotionMakerXLCheckBox")
        control:SetSimpleAnchorParent(xPosMustNotFilter, (control:GetHeight()+2)*cnt)
        ZO_CheckButton_SetToggleFunction(control, PotMakerXL.checkAll)
        local labelControl = CreateControlFromVirtual("PotionMakerXLAllMustNotCheckBoxText", control, "PotionMakerXLCheckBoxText")
        labelControl:SetText(PME_Lang[language].check_all)
    end
	
	-- reinit solvent display
	for i=1,PotionMakerXLSolventBG:GetNumChildren() do
		if string.find(PotionMakerXLSolventBG:GetChild(i):GetName(), "PotionMakerXLReagent") ~= nil and string.find(PotionMakerXLSolventBG:GetChild(i):GetName(), "PotionMakerXLReagentBG") == nil then
			PotionMakerXLSolventBG:GetChild(i):SetHidden(not PotMakerXL.useMissing)
		end
	end
--    if #PotMakerXL.SolventFilterControls == 0 then
		-- order by level
		local index = 1
		local tempOrder = {}
		for solvent, stack in pairs(PotMakerXL.Inventory.solvents) do
			table.insert(tempOrder, solvent.level..solvent.name)
		end
		table.sort(tempOrder)
--		d(tempOrder)
		for _, name in pairs(tempOrder) do
			-- place solvent in order
			for solvent, stack in pairs(PotMakerXL.Inventory.solvents) do
 				if solvent.level..solvent.name == name then
					local controlName = "PotionMakerXLReagent" .. solvent.name:gsub(" ", "")
					local control = WINDOW_MANAGER:GetControlByName(controlName)
					if control == nil then
						control = CreateControlFromVirtual(controlName, PotionMakerXLSolventBG, "PotionMakerXLReagent")
						control.text = solvent.name
						local labelControl = CreateControlFromVirtual(controlName .. "Text", control, "PotionMakerXLCheckBoxText")
						labelControl:SetText(PME_Lang[language].level.." "..solvent.level)
					else
						control:SetHidden(false)
					end
					control:SetSimpleAnchorParent(xPosSolventFilter, (control:GetHeight()+0)*(index-1)+0)
					control.reagent = solvent
					local iconControl = WINDOW_MANAGER:GetControlByName(controlName .. "Texture")
					local labelControl = WINDOW_MANAGER:GetControlByName(controlName .. "Number")
					iconControl:SetTexture(solvent.icon)
					labelControl:SetText(stack)
					PotMakerXL.SolventFilterControls[index] = control
					index = index + 1
					break
				end
			end
        end
--    end
	
 --   if #PotMakerXL.ReagentFilterControls == 0 then
		--reinit reagent display
		for i=1,PotionMakerXLReagentBG:GetNumChildren() do
			if string.find(PotionMakerXLReagentBG:GetChild(i):GetName(), "PotionMakerXLReagent") ~= nil and string.find(PotionMakerXLReagentBG:GetChild(i):GetName(), "PotionMakerXLReagentBG") == nil then
				PotionMakerXLReagentBG:GetChild(i):SetHidden(not PotMakerXL.useMissing)
			end
		end

		-- display reagent from inventory
		--order by name first
		local index = 1
		local tempOrder = {}
		for ingredient, stack in pairs(PotMakerXL.Inventory.reagents) do
			if PotionMakerSavedVariables.reagentStackOrder then
				table.insert(tempOrder, string.format("%03d", stack)..ingredient.name)
			else
				table.insert(tempOrder, ingredient.name)
			end
			end
		table.sort(tempOrder) -- order by name (or by stack if option)
--		d(tempOrder)
		for _, name in pairs(tempOrder) do
			-- place ingredient in order
			for ingredient, stack in pairs(PotMakerXL.Inventory.reagents) do
				if (not PotionMakerSavedVariables.reagentStackOrder and ingredient.name == name) or (PotionMakerSavedVariables.reagentStackOrder and (string.format("%03d", stack)..ingredient.name) == name) then
					local controlName = "PotionMakerXLReagent" .. ingredient.name:gsub(" ", "")
					local control = WINDOW_MANAGER:GetControlByName(controlName)
					if control == nil then
						control = CreateControlFromVirtual(controlName, PotionMakerXLReagentBG, "PotionMakerXLReagent")
					else
						control:SetHidden(false)
					end
					control:SetSimpleAnchorParent(8+40*((index-1)%4), (control:GetHeight()+0)*(math.floor((index-1)/4)))
					control.reagent = ingredient
					-- ZO_CheckButton_SetToggleFunction(control, PotMakerXL.solventCheckButtonClicked)
					local iconControl = WINDOW_MANAGER:GetControlByName(controlName .. "Texture")
					local labelControl = WINDOW_MANAGER:GetControlByName(controlName .. "Number")
					iconControl:SetTexture(ingredient.icon)
					labelControl:SetText(stack)
					PotMakerXL.ReagentFilterControls[index] = control
					index = index + 1
					break
				end
			end
        end
 --   end
end

function PotMakerXL.close()
    PotMakerXL.endAlchemy()
end

function PotMakerXL:GetLanguage()
	local lang = GetCVar("language.2")
--	lang = "en" --for testing
	
	--supported languages
	if(lang == "fr") then return lang end
	if(lang == "de") then return lang end
	if(lang == "es") then return lang end
	if(lang == "ru") then return lang end

	--return english if not supported
	return "en"
end

function PotMakerXL.init(eventCode, addOnName)
    if addOnName ~= "PotionMakerExtended" then return end

	language = PotMakerXL:GetLanguage()
    PotionMakerSavedVariables = ZO_SavedVars:New("PotionMakerExtended_Data", 1, nil, PotMakerXL.dataDefaults, nil)
    PotMakerXL:initVar(language)
	PotMakerXL:initMenu()
    PotMakerXL:initWindows()

    SLASH_COMMANDS["/potionmaker"] = function()
		SetGameCameraUIMode(true)
		PotMakerXL.doAlchemy()
	end
end

function PotMakerXL:initMenu()

	PotionMakerXLMsgWindow = LIBMW:CreateMsgWindow((PotMakerXL.name.."Msg"):gsub(" ",""), PotMakerXL.name.." |c"..COLOR_KHRILLSELECT.."Extended|r", 20000, 2000)
	PotionMakerXLMsgWindow:SetHidden(true)
	PotionMakerXLMsgWindow:SetDimensions(300, 300)
	PotionMakerXLMsgWindow:ClearAnchors()
	PotionMakerXLMsgWindow:SetAnchor(TOPLEFT, ZO_ChatWindowBg, TOPRIGHT, -10, 0)
	PotionMakerXLMsgWindow:ChangeTextFade(20000, 2000)	

	--// Settings panel LAM2
	local LAM2 = LibStub("LibAddonMenu-2.0")
	if ( not LAM2 ) then return end
	
	local ADDON_NAME= PotMakerXL.name .." |cFF6A00Extended|r"
	local ADDON_VERSION="v"..PotMakerXL.version
	local panelData = {
			type = "panel",
			name = ADDON_NAME,
			displayName = ADDON_NAME .." (" .. language .. ")",
			author = "|cFFFFFFfacit|r (Original) - |c"..COLOR_KHRILLSELECT.."Khrill|r (Extended)",
			version = ADDON_VERSION,
			slashCommand = "/pmcfg",
			registerForRefresh = true,
			registerForDefaults = true,
	}
	LAM2:RegisterAddonPanel(ADDON_NAME, panelData)

	local optionsTable = {
		------------GENERAL--------------
		{
			type = "header",
			name = "|c"..COLOR_KHRILLSELECT..PME_Lang[language].settings_short.."|r",
			width = "full",	--or "half" (optional)
		},
		{ -- Enable button
			type = "checkbox",
			name = PME_Lang[language].settings_enableBtn,
			tooltip = PME_Lang[language].settings_enableBtn,
			getFunc = function() return PotionMakerSavedVariables.enableButton end,
			setFunc = function(value) PotMakerXL:toggleEnableBtn(value) end,
			width = "full",	
			default = PotMakerXL.dataDefaults.enableButton,
		},
		{	-- MenuSameCoordsEdit
			type = "checkbox",
			name = PME_Lang[language].same_window_coords_short,
			tooltip = PME_Lang[language].same_window_coords_long,
			getFunc = function() return PotionMakerSavedVariables.sameWindowCoords end,
			setFunc = function(value) PotionMakerSavedVariables.sameWindowCoords = value end,
			width = "full",	--or "half" (optional)
			default = PotMakerXL.dataDefaults.sameWindowCoords,
		},
		{	-- MenuUseUnknownEdit
			type = "checkbox",
			name = PME_Lang[language].use_unknown_traits_short,
			tooltip = PME_Lang[language].use_unknown_traits_long,
			getFunc = function() return PotionMakerSavedVariables.useUnknown end,
			setFunc = function(value)
				PotionMakerSavedVariables.useUnknown = value
				PotionMakerSavedVariables.training = false
			end,
			width = "full",	--or "half" (optional)
			default = PotMakerXL.dataDefaults.useUnknown,
		},
		{	-- MenuTrainingEdit
			type = "checkbox",
			name = PME_Lang[language].training_short,
			tooltip = PME_Lang[language].training_long,
			getFunc = function() return PotionMakerSavedVariables.training and PotionMakerSavedVariables.useUnknown end,
			setFunc = function(value) PotionMakerSavedVariables.training = value end,
			width = "full",	--or "half" (optional)
			default = PotMakerXL.dataDefaults.training,
			disabled = function() return not PotionMakerSavedVariables.useUnknown end,
		},
		{	-- MenuUseMissingEdit
			type = "checkbox",
			name = PME_Lang[language].use_missing_reagents_short,
			tooltip = PME_Lang[language].use_missing_reagents_long,
			warning = use_missing_reagents_warning,
			getFunc = function() return PotionMakerSavedVariables.useMissing end,
			setFunc = function(value) PotionMakerSavedVariables.useMissing = value end,
			width = "full",	--or "half" (optional)
			default = PotMakerXL.dataDefaults.useMissing,
		},
 --   if not IsThirdAlchemySlotUnlocked() then
		{	-- MenuFakeThirdSlotEdit
			type = "checkbox",
			name = PME_Lang[language].fake_third_slot_short,
			tooltip = PME_Lang[language].fake_third_slot_long,
			getFunc = function() return PotionMakerSavedVariables.fakeThirdSlot end,
			setFunc = function(value) PotionMakerSavedVariables.fakeThirdSlot = value end,
			width = "full",	--or "half" (optional)
			default = PotMakerXL.dataDefaults.fakeThirdSlot,
			disabled = function() return IsThirdAlchemySlotUnlocked() end,
		},
--    end
		{	-- Show XP
			type = "checkbox",
			name = PME_Lang[language].show_xp_short,
			tooltip = PME_Lang[language].show_xp_long,
			getFunc = function() return PotionMakerSavedVariables.XPMode end,
			setFunc = function(value) PotionMakerSavedVariables.XPMode = value end,
			width = "full",	--or "half" (optional)
			default = PotMakerXL.dataDefaults.XPMode,
		},
		{	-- Reagent Stack order
			type = "checkbox",
			name = PME_Lang[language].reagent_stackorder_short,
			tooltip = PME_Lang[language].reagent_stackorder_long,
			getFunc = function() return PotionMakerSavedVariables.reagentStackOrder end,
			setFunc = function(value) PotionMakerSavedVariables.reagentStackOrder = value end,
			width = "full",	--or "half" (optional)
			default = PotMakerXL.dataDefaults.reagentStackOrder,
		},
		{	-- Reagent level's color display
			type = "checkbox",
			name = PME_Lang[language].reagent_levelcolor_short,
			tooltip = PME_Lang[language].reagent_levelcolor_long,
			getFunc = function() return PotionMakerSavedVariables.reagentLevelColor end,
			setFunc = function(value) PotionMakerSavedVariables.reagentLevelColor = value end,
			width = "full",	--or "half" (optional)
			default = PotMakerXL.dataDefaults.reagentLevelColor,
		},
	}

	LAM2:RegisterOptionControls(ADDON_NAME, optionsTable)	
end

function PotMakerXL.Initialized()
    EVENT_MANAGER:RegisterForEvent("PotionMakerExtended", EVENT_ADD_ON_LOADED, PotMakerXL.init)
    EVENT_MANAGER:RegisterForEvent("PotionMakerExtended", EVENT_CRAFTING_STATION_INTERACT, PotMakerXL.interactWithAlchemyStation)
    EVENT_MANAGER:RegisterForEvent("PotionMakerExtended", EVENT_END_CRAFTING_STATION_INTERACT, PotMakerXL.endAlchemy)
    EVENT_MANAGER:RegisterForEvent("PotionMakerExtended", EVENT_CRAFT_COMPLETED, PotMakerXL.craftCompleted)
end

PotMakerXL.Initialized()